PS_maxlines = 11;
PS_debugmode = true;
PS_mom = 0;
PS_addpop = 0;
PS_width = 0;
PS_mocheck = 0;
PS_sendmsg = "";
PS_neww = 0;
PS_tpos = 0;
PS_id = 0;
PS_cchck = nil;
PS_line = nil;
PS_thelist = "";
PS_newline = nil;
PS_faction = UnitFactionGroup("player");
PS_starttime = GetTime() - 3;
PS_ClickTime = GetTime() - 2;
PS_lastpinged = "";
PS_lasttip = nil;
PS_bgmode = false;
PS_skipchk = false;
PS_CombatMode = "";
PS_mapsend = 0;
PS_stealth = false;
PS_phasetime = nil;
PS_DeathTime = nil;
PS_DeathName = "nil";
PS_FromMouse = false;
PS_add = nil;
PS_MMT = false;
PS_dim = 0;
PS_CSG = 0;
PS_X = 0;
PS_Y = 0;
PS_NeutralZones = {
  "Booty Bay",
  "Gadgetzan",
  "Marshall's Refuge",
  "Everlook",
  "Cenarion Hold",
  "Light's Hope Chapel",
  "Thorium Point",
  "Nighthaven",
  "Shattrath",
  "The Salty Sailor Tavern"
  }

function PS_OnLoad()

  this:RegisterEvent("ZONE_CHANGED");
  this:RegisterEvent("PLAYER_ENTERING_WORLD");
  this:RegisterEvent("VARIABLES_LOADED");
  this:RegisterEvent("PLAYER_TARGET_CHANGED");
  this:RegisterEvent("UPDATE_BATTLEFIELD_SCORE");
  this:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
  this:RegisterEvent("UPDATE_BATTLEFIELD_SCORE");
  this:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
  this:RegisterEvent("SPELLCAST_CHANNEL_START");
  this:RegisterEvent("CHAT_MSG_SYSTEM");
  this:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS");
  this:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_PARTY_MISSES");
  this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE");
  this:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_MISSES");
  this:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS");
  this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE");
  this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE");
  this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_BUFFS");
  this:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE");
  this:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_BUFF");
  this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS");
  this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILEPLAYER_MISSES");
  this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH");
  this:RegisterEvent("CHAT_MSG_COMBAT_FRIENDLY_DEATH");
  this:RegisterEvent("CHAT_MSG_COMBAT_HONOR_GAIN");
  lOriginal_Minimap_OnClick_Event = Minimap_OnClick;
  Minimap_OnClick = PS_Minimap_OnClick_Event;
  SlashCmdList["PS"] = function(msg)
    PS_Slash(msg);
  end
  SLASH_PS1 = "/PS";
  SLASH_PS2 = "/personalsentry";
end

function PS_ToggleLock()

  PSvars.Locked = not PSvars.Locked;
  PS_UpdateLock();
end

function PS_UpdateLock()

  local classicon = getglobal("PS_PopupButton1"..PS_CombatMode..PSvars.PopupMode.."ButtonClassIcon");
  if PSvars.Locked then
    classicon:SetTexture("Interface\\AddOns\\Personal Sentry\\Images\\locked");
  else
    classicon:SetTexture("Interface\\AddOns\\Personal Sentry\\Images\\unlocked");
  end
  getglobal("PS_Popup"..PS_CombatMode..PSvars.PopupMode):Show();
end

function PS_ToggleMinimapButton()

  PSvars.MiniIcon = not PSvars.MiniIcon;
  PS_Minimap_RefreshMinimap();
  if not PSvars.MiniIcon then
    PS_TraceFrame(PS_HIDDEN);
  end
end

function PS_TraceFrame(text)

  DEFAULT_CHAT_FRAME:AddMessage(PS_WARNING..text, 1, .25, .3)
end

function PS_ShowCustom(note)

  local Class = UnitClass("Player");
  local Level = UnitLevel("Player");
  local Race = UnitRace("Player");
  local Name = UnitName("Player");
  if note == "warning" then
    local Loc = GetMinimapZoneText();
    local x, y = GetPlayerMapPosition("player");
    local iX = math.floor(x*100);
    local iY = math.floor(y*100);
    local xy = iX..", "..iY;
    PS_sendmsg = PSvars.CustomWarning;
    PS_sendmsg = string.gsub(PS_sendmsg, '%%w', PS_DF..PS_PLAYER);
    PS_sendmsg = string.gsub(PS_sendmsg, '%%n', Name);
    PS_sendmsg = string.gsub(PS_sendmsg, '%%c', Class);
    PS_sendmsg = string.gsub(PS_sendmsg, '%%l', Level);
    PS_sendmsg = string.gsub(PS_sendmsg, '%%r', Race);
    PS_sendmsg = string.gsub(PS_sendmsg, '%%x', xy);
    PS_sendmsg = string.gsub(PS_sendmsg, '%%z', Loc);
  else
    PS_sendmsg = "|"..PSvars.CustomPopup;
    PS_sendmsg = string.gsub(PS_sendmsg, '%%n', Name);
    PS_sendmsg = string.gsub(PS_sendmsg, '%%c', Class);
    PS_sendmsg = string.gsub(PS_sendmsg, '%%l', Level);
    PS_sendmsg = string.gsub(PS_sendmsg, '%%r', Race);
    if string.find(PS_sendmsg, "%%d") then
      PS_sendmsg = "{Damage numbers appear here} "..PS_sendmsg;
      PS_sendmsg = string.gsub(PS_sendmsg, ' %%d', "");
      PS_sendmsg = string.gsub(PS_sendmsg, '%%d ', "");
      PS_sendmsg = string.gsub(PS_sendmsg, '%%d', "");
    end
    PS_sendmsg = PS_sendmsg.." |";
    if string.find(PS_sendmsg, "nohealth") then
      PS_sendmsg = string.gsub(PS_sendmsg, ' nohealth', "");
      PS_sendmsg = string.gsub(PS_sendmsg, 'nohealth ', "");
      PS_sendmsg = string.gsub(PS_sendmsg, 'nohealth', "");
      PS_sendmsg = PS_sendmsg.." [No healthbar]";
    end
    if string.find(PS_sendmsg, "%%p") then
      PS_sendmsg = string.gsub(PS_sendmsg, ' %%p', "");
      PS_sendmsg = string.gsub(PS_sendmsg, '%%p ', "");
      PS_sendmsg = string.gsub(PS_sendmsg, '%%p', "");
      PS_sendmsg = PS_sendmsg.." <Text by class color>";
    end
  end
  DEFAULT_CHAT_FRAME:AddMessage(PS_CUSTOM, .3, 1, .75);
  DEFAULT_CHAT_FRAME:AddMessage(PS_sendmsg, .3, 1, .75);
  PS_sendmsg = "";
end

function PS_GetFoundString(name, data)

  local found = name.." ("..data.Level;
  if data.Race ~= nil then
    found = found..data.Race;
  end
  found = found.." "..data.Class..")";
  if data.Zone ~= nil and data.Zone ~= "" then
    found = found..". Last seen at "..data.Zone;
  end
  if data.SubZone ~= nil and data.SubZone ~= "" then
    found = found.."/"..data.SubZone;
  end
  return found;
end

function PS_SearchTarget(target)

  local counter = 0;
  local nilcount = 0;
  local found = "";
  DEFAULT_CHAT_FRAME:AddMessage( "Searching:"..target, 1, 1, 1);
  if PS_faction == "Alliance" then
    for name, data in pairs(PSvars.EnemyPlayers) do
      if string.find(string.lower(name), target) then
        found = PS_GetFoundString(name, data);
        counter = counter + 1;
        DEFAULT_CHAT_FRAME:AddMessage(counter..":"..found, 1, 0, 0);
      end
    end
    for name, data in pairs(PSvars.EnemyMobs) do
      if string.find(string.lower(name), target) then
        found = PS_GetFoundString(name, data);
        counter = counter + 1;
        DEFAULT_CHAT_FRAME:AddMessage(counter..":"..found, 1, .50, 0);
      end
    end
    for name, data in pairs(PSvars.FriendlyPlayers) do
      if string.find(string.lower(name), target) then
        found = PS_GetFoundString(name, data);
        counter = counter + 1;
        DEFAULT_CHAT_FRAME:AddMessage(counter..":"..found, 0, 1, 0);
      end
    end
    for name, data in pairs(PSvars.FriendlyMobs) do
      if string.find(string.lower(name), target) then
        found = PS_GetFoundString(name, data);
        counter = counter + 1;
        DEFAULT_CHAT_FRAME:AddMessage(counter..":"..found, .70, 1, .70);
      end
    end
  else
    for name, data in pairs(PSvars.EnemyP) do
      if string.find(string.lower(name), target) then
        found = PS_GetFoundString(name, data);
        counter = counter + 1;
        DEFAULT_CHAT_FRAME:AddMessage(counter..":"..found, 1, 0, 0);
      end
    end
    for name, data in pairs(PSvars.EnemyM) do
      if string.find(string.lower(name), target) then
        found = PS_GetFoundString(name, data);
        counter = counter + 1;
        DEFAULT_CHAT_FRAME:AddMessage(counter..":"..found, 1, .50, 0);
      end
    end
    for name, data in pairs(PSvars.FriendlyP) do
      if string.find(string.lower(name), target) then
        found = PS_GetFoundString(name, data);
        counter = counter + 1;
        DEFAULT_CHAT_FRAME:AddMessage(counter..":"..found, 0, 1, 0);
      end
    end
    for name, data in pairs(PSvars.FriendlyM) do
      if string.find(string.lower(name), target) then
        found = PS_GetFoundString(name, data);
        counter = counter + 1;
        DEFAULT_CHAT_FRAME:AddMessage(counter..":"..found, .70, 1, .70);
      end
    end
  end
  DEFAULT_CHAT_FRAME:AddMessage("Found:"..counter.." entries.", 1, 1, 1);
end

function PS_Slash(msg)

  local target = nil;
  local lmsg = string.lower(msg);
  if string.find(lmsg, "options") then
    PS_OptionsForm_InitializeOptions();
    PS_OptionsForm:Show();
  elseif string.find(lmsg, "search") then
    for target in string.gmatch(lmsg, "search (%a+)") do
      PS_SearchTarget(target);
    end
  elseif string.find(lmsg, "debug") then
    PS_debugmode = not PS_debugmode;
    if PS_debugmode then
      DEFAULT_CHAT_FRAME:AddMessage("PS Debug : ON.", 1, 1, 0);
    else
      DEFAULT_CHAT_FRAME:AddMessage("PS Debug : OFF.", 1, 1, 0);
    end
  elseif (string.sub(lmsg,1,7) == "warnmsg") then
    if (string.len(lmsg) > 8) then
      PSvars.CustomWarning = string.sub(msg,9);
      if string.lower(PSvars.CustomWarning) == "reset" then
        PSvars.CustomWarning = "";
        PS_TraceFrame(PS_CWR);
      else
        PS_ShowCustom("warning");
      end
    else
      PS_Slash("/ps custom");
    end
  elseif (string.sub(lmsg,1,8) == "popupmsg") then
    if (string.len(lmsg) > 9) then
      PSvars.CustomPopup = string.sub(msg,10);
      if string.lower(PSvars.CustomPopup) == "reset" then
        PSvars.CustomPopup = "";
        PS_TraceFrame(PS_CPR);
      else
        PS_ShowCustom("popup");
      end
      for i=2, 11 do
        getglobal("PS_PopupButton"..i..PS_CombatMode.."Dam"..PSvars.PopupMode.."Button"):SetText("");
        getglobal("PS_PopupButton"..i..PS_CombatMode.."Dam"..PSvars.PopupMode):SetAlpha(0);
        getglobal("PS_PopupButton"..i..PS_CombatMode.."Dam"..PSvars.PopupMode):Hide();
      end
    else
      PS_Slash("/ps custom");
    end
    PS_Clear_Popup();
    PS_dim = 1;
    PS_Process_Tooltip(PS_thelist);
  elseif string.find(lmsg, "custom") then
    DEFAULT_CHAT_FRAME:AddMessage("Custom Popup and Announcement Functions", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("---------------------------------------------------", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("%p - Displays the text color according to class.", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("%l - Displays the LEVEL of the target.", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("%n - Displays the NAME of the target.", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("%c - Displays the CLASS of the target.", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("%r - Displays the RACE of the target.", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("%d - Displays the DAMAGE to you by the target (outside the popup).", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("nohealth - Disables the health display of targets on the popup.", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage(" ", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("Custom Announcement Functions ONLY", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("---------------------------------------------", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("%w - Adds 'Detecting/WARNING Friendy/Enemy Player/NPC' to your announcement.", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("%z - Displays the zone or sub-zone where you saw the target.", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("%x - Displays the numeric map location of the target in format x, y.", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage(" ", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("Use '/ps popupmsg' or '/ps warnmsg' to create custom displays.", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("Example:", .4, 1, .4);
    DEFAULT_CHAT_FRAME:AddMessage("/ps popupmsg [%l %c] %n -%r- nohealth", .6, .6, 1);
    DEFAULT_CHAT_FRAME:AddMessage("will display on the popup as:", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("[61 Druid] Filche -Tauren- (no colored healthbar [transparent])", .6, .6, 1);
    DEFAULT_CHAT_FRAME:AddMessage("Example2:", .4, 1, .4);
    DEFAULT_CHAT_FRAME:AddMessage("/ps warnmsg %w %n wants his level %l %c butt kicked near %z <%x>", 1, .6, .6);
    DEFAULT_CHAT_FRAME:AddMessage("will announce this message:", 1, 1, 1);
    DEFAULT_CHAT_FRAME:AddMessage("-WARNING!- Enemy Player Filche wants his level 61 Tauren butt kicked near Thrallmar <56, 37>", 1, .6, .6);
    if (PSvars.CustomPopup ~= "" or PSvars.CustomWarning ~= "") then
      DEFAULT_CHAT_FRAME:AddMessage(" ", 1, 1, 1);
      if PSvars.CustomPopup ~= "" then
        DEFAULT_CHAT_FRAME:AddMessage("Current custom popup message: "..PSvars.CustomPopup);
      end
      if PSvars.CustomWarning ~= "" then
        DEFAULT_CHAT_FRAME:AddMessage("Current custom announcement: "..PSvars.CustomWarning);
      end
    end
  elseif string.find(lmsg, "hitlist") then
    if (string.len(lmsg) > 8) then
      for data in string.gmatch(lmsg, "hitlist (%a+)") do
        local beg = string.sub(data, 1, 1);
        local hind = string.sub(data, 2);
        beg = string.upper(beg);
        data = beg..hind;
        if PS_faction == "Alliance" then
          targetData = PS_GetEnemyPlayer(data);
        else
          targetData = PS_HordeEnemyP(data);
        end
        if targetData ~= nil then
          if not targetData.IsKOS then
            targetData.IsKOS = true;
            if PS_faction == "Alliance" then
              PSvars.EnemyPlayers[data] = targetData;
            else
              PSvars.EnemyP[data] = targetData;
            end
            local listData = PS_GetListData(data);
            if listData ~= nil then
              if listData.damage == 0 then
                listData.damage = "HITLIST";
                PSvars.list[data] = listData;
              end
            end
            local level = targetData.Level;
            if tonumber(level) == -1 then
              level = (UnitLevel("player") + 10) .. "+";
            end
            if tonumber(level) == -2 then
              level = "??";
            end
            DEFAULT_CHAT_FRAME:AddMessage(data.." ["..level.." "..targetData.Race.." "..targetData.Class.."]: "..PS_AHL, 1, .3, .6);
            if PSvars.SentrySound then
              PlaySoundFile("Interface\\AddOns\\Personal Sentry\\sounds\\hitadd.wav");
            end
          else
            targetData.IsKOS = false;
            if PS_faction == "Alliance" then
              PSvars.EnemyPlayers[data] = targetData;
            else
              PSvars.EnemyP[data] = targetData;
            end
            local listData = PS_GetListData(data);
            if listData ~= nil then
              if listData.damage == "HITLIST" then
                listData.damage = 0;
                PSvars.list[data] = listData;
              end
            end
            local level = targetData.Level;
            if tonumber(level) == -1 then
              level = (UnitLevel("player") + 10) .. "+";
            end
            if tonumber(level) == -2 then
              level = "??";
            end
            DEFAULT_CHAT_FRAME:AddMessage(data.." ["..level.." "..targetData.Race.." "..targetData.Class.."]: "..PS_RHL, .3, 1, .6);
            if PSvars.SentrySound then
              PlaySoundFile("Interface\\AddOns\\Personal Sentry\\sounds\\hitremove.wav");
            end
          end
        else
          DEFAULT_CHAT_FRAME:AddMessage(data..PS_NOT, .6, .6, .6);
        end
      end
    else
      local counter = 0;
      DEFAULT_CHAT_FRAME:AddMessage("Your current 'Hit List':", 1, 1, 1);
      DEFAULT_CHAT_FRAME:AddMessage("---------------------------------", 1, 1, 1);
      if PS_faction == "Alliance" then
        for name, targetData in pairs(PSvars.EnemyPlayers) do
          if targetData.IsKOS then
            local level = targetData.Level;
            if tonumber(level) == -1 then
              level = (UnitLevel("player") + 10) .. "+";
            end
            if tonumber(level) == -2 then
              level = "??";
            end
            DEFAULT_CHAT_FRAME:AddMessage(name.." ["..level.." "..targetData.Race.." "..targetData.Class.."]",1,1,1);
            counter = counter + 1;
          end
        end
      else
        for name, targetData in pairs(PSvars.EnemyP) do
          if targetData.IsKOS then
            local level = targetData.Level;
            if tonumber(level) == -1 then
              level = (UnitLevel("player") + 10) .. "+";
            end
            if tonumber(level) == -2 then
              level = "??";
            end
            DEFAULT_CHAT_FRAME:AddMessage(name.." ["..level.." "..targetData.Race.." "..targetData.Class.."]",1,1,1);
            counter = counter + 1;
          end
        end
      end
      if counter > 0 then
        DEFAULT_CHAT_FRAME:AddMessage(counter.." total enemy players.",1,1,1);
      else
        DEFAULT_CHAT_FRAME:AddMessage("You have no enemy players listed yet!",1,1,1);
      end
    end
  else
    DEFAULT_CHAT_FRAME:AddMessage(PS_version,1,.1,1);
    DEFAULT_CHAT_FRAME:AddMessage(" ",1 ,1 ,0);
    DEFAULT_CHAT_FRAME:AddMessage("Popup functions list:",1,1,1);
    DEFAULT_CHAT_FRAME:AddMessage("=====================",1,1,1);
    DEFAULT_CHAT_FRAME:AddMessage("Left-click - Targets the unit.",1,1,.25);
    DEFAULT_CHAT_FRAME:AddMessage("Right-click - Targets AND announces the unit.",1,1,.25);
    DEFAULT_CHAT_FRAME:AddMessage("Shift right-click - Force announce, even if it can't target first.",1,1,.25);
    DEFAULT_CHAT_FRAME:AddMessage("Control right-click - Forces a ping on the minimap with the announcement.",1,1,.25);
    DEFAULT_CHAT_FRAME:AddMessage("Shift left-click - Toggles an enemy player on your 'Hit List'.",1,1,.25);
    DEFAULT_CHAT_FRAME:AddMessage(" ",1 ,1 ,0);
    DEFAULT_CHAT_FRAME:AddMessage("Command line functions:",1,1,1);
    DEFAULT_CHAT_FRAME:AddMessage("=======================",1,1,1);
    DEFAULT_CHAT_FRAME:AddMessage("/PS options - Opens the options menu.",1,1,.5);
    DEFAULT_CHAT_FRAME:AddMessage("/PS search (target name) - Searches through target database.",1,1,.5);
    DEFAULT_CHAT_FRAME:AddMessage("/PS custom - Lists custom message functions and examples.",1,1,.5);
    DEFAULT_CHAT_FRAME:AddMessage("/PS popupmsg (text) - Sets a custom popup display.",1,1,.5);
    DEFAULT_CHAT_FRAME:AddMessage("/PS warnmsg (text) - Sets a custom announcement.",1,1,.5);
    DEFAULT_CHAT_FRAME:AddMessage("/PS hitlist - Displays your current enemy player 'Hit List'.",1,1.5);
    DEFAULT_CHAT_FRAME:AddMessage("/PS hitlist (target name) - Toggles a known enemy player to your 'Hit List'.",1,1,.5);
  end
end

function PS_CountPairs(pairtable)

  local counter = 0;
  for name, data in pairs(pairtable) do
    counter = counter + 1
  end
  return counter;
end

function PS_OnEvent(event, eventdata)

  local SentryCheck = true;
  if (PSvars.SentryMode and PSvars.SentryChk) then
    local subzone = GetSubZoneText();
    for i = 1, table.getn(PS_NeutralZones) do
      if subzone == PS_NeutralZones[i] then
        SentryCheck = false;
      end
    end
  end
  if (event == "VARIABLES_LOADED") then
    PS_LoadSavedVariables();
    PS_OptionsForm:Hide();
    PS_OptionsForm_InitializeOptions();
    if DEFAULT_CHAT_FRAME then
      DEFAULT_CHAT_FRAME:AddMessage(PS_version);
      if PSvars.SentryMode then
        DEFAULT_CHAT_FRAME:AddMessage(PS_SENTRYON);
      else
        DEFAULT_CHAT_FRAME:AddMessage(PS_SENTRYOFF);
      end
      PS_CombatMode = "Com";
      PS_Clear_Popup();
      PS_CombatMode = "";
      PS_Clear_Popup();
    end
    PS_UpdateLock();
    PS_PurgeTempEntries();
    if PSvars.Addons == "OFF" then
      PS_TraceFrame(PS_DISABLED);
    end
    return;
  end
  local zonetext = GetRealZoneText();
  if PS_ZoneIsABG(zonetext) then
    PS_bgmode = true;
  else
    PS_bgmode = false;
  end
  if (event == "PLAYER_ENTERING_WORLD") then
    if not UnitIsDeadOrGhost("player") then
      PS_Clear_Popup();
      PS_thelist = "";
      PSvars.list = {};
    end
  end
  if (PSvars.Addons == "ON" or (PSvars.Addons == "BG" and PS_bgmode)) then
    if (event == "PLAYER_TARGET_CHANGED") then
      if(UnitName("target") ~= nil) then
        if PS_cchck ~= nil then
          if (UnitName("target") ~= PS_cchck) then
            return;
          end
          if(PS_UserWantsToPing() or IsControlKeyDown()) then
            if (PS_X ~= 999 and PS_Y ~= 999) then
              Minimap:PingLocation(PS_X, PS_Y);
            end
          end
        end
        local rfrsh = false;
        local unitname = UnitName("target");
        local level = UnitLevel("target");
        local class = UnitClass("target");
        local isenemy = UnitIsEnemy("target", "player");
        local isplayer = UnitIsPlayer("target");
        local race = UnitRace("target");
        local faction = UnitFactionGroup("target");
        targetData = PS_GetUnitData(unitname);
        targetData.Zone = GetRealZoneText();
        targetData.SubZone = GetSubZoneText();
        local listData = PS_GetListData(unitname);
        targetData.Class = class;
        targetData.Race = race;
        targetData.Level = level;
        targetData.IsTemp = PS_bgmode;
        if((PSvars.storage == "PLAYERS" and not isplayer) or (PSvars.storage == "NPC" and isplayer) or PSvars.storage == "NONE") then
          targetData.IsTemp = true;
        end
        if tonumber(level) == -1 then
          level = (UnitLevel("player") + 10) .. "+";
        end
        if tonumber(level) == -2 then
          level = "??";
        end
        PS_AddDBEntry(unitname, targetData, isenemy, isplayer, faction);
        if ((PSvars.tracking == "ENEMY PLAYERS" and (not isplayer or not isenemy)) or (PSvars.tracking == "ALL PLAYERS" and not isplayer) or (PSvars.tracking == "ENEMIES" and not isenemy)) then
          PS_Clear_Popup();
          PS_addpop = 0;
          local thelist = PS_thelist;
          PS_thelist = "";
          PS_KeepDamage(thelist);
          PS_Process_Tooltip(thelist);
          return;
        end
        if listData.pos > 1 then
          damage = listData.damage;
          PS_id = listData.pos;
          listData.time = GetTime();
          listData.phase = 1;
          listData.health = UnitHealth("target");
          PSvars.list[unitname] = listData;
          getglobal("PS_PopupButton"..listData.pos..PS_CombatMode..PSvars.PopupMode.."ButtonBar"):SetAlpha(listData.phase);
          rfrsh = true;
        elseif UnitName("target") ~= UnitName("player") then
          if (PSvars.SentryMode and SentryCheck) then
            if (PSvars.tracking == "ALL" and UnitCreatureType("target") ~= "Critter" and level ~=1 and not UnitIsDeadOrGhost("target")) then
              if (isplayer and UnitIsPVP("target")) then
                PS_CaptureAttack(unitname, "you", nil, "target", 1);
              elseif not isplayer then
                local xx = 0;
                local name = UnitName("target");
                for target in string.gmatch(name, "Spirit Guide") do
                  xx = 1;
                end
                for target in string.gmatch(name, " Totem") do
                  xx = 1;
                end
                for target in string.gmatch(name, " Trap") do
                  xx = 1;
                end
                for target in string.gmatch(name, "Mechanical Squirrel") do
                  xx = 1;
                end
                if xx == 0 then
                  PS_CaptureAttack(unitname, "you", nil, "target", 1);
                end
              end
            elseif (PSvars.tracking == "ALL PLAYERS" and not UnitIsDeadOrGhost("target")) then
              if (isplayer and UnitIsPVP("target")) then
                PS_CaptureAttack(unitname, "you", nil, "target", 1);
              end
            elseif (PSvars.tracking == "ENEMIES" and UnitLevel("target") ~= 1 and isenemy and not UnitIsDeadOrGhost("target")) then
              if (isplayer and UnitIsPVP("target")) then
                PS_CaptureAttack(unitname, "you", nil, "target", 1);
              elseif not isplayer then
                PS_CaptureAttack(unitname, "you", nil, "target", 1);
              end
            else
              if (isenemy and isplayer and UnitIsPVP("target") and not UnitIsDeadOrGhost("target")) then
                PS_CaptureAttack(unitname, "you", nil, "target", 1);
              end
            end
          end
        end
        if rfrsh then
          PS_Refresh(unitname, isplayer, isenemy, "target", level, race, class, listData.pos);
          if isenemy then
            setag = PS_WE;
          else
            setag = PS_DF;
          end
          if isplayer then
            setmess = PS_PLAYER;
            srace = " "..race;
            sclass =" "..class;
            if tonumber(level) == -1 then
              level = (UnitLevel("player") + 10) .. "+";
            end
            if tonumber(level) == -2 then
              level = "??";
            end
          else
            setmess = "NPC: ";
            srace = "";
            sclass = "";
          end
          Loc = GetMinimapZoneText();
          x, y = GetPlayerMapPosition("player");
          iX = math.floor(x*100);
          iY = math.floor(y*100);
          xy = iX..", "..iY;
          if PSvars.CustomWarning == "" then
            PS_sendmsg = setag..setmess..unitname.." ("..level..srace..sclass..")";
            PS_sendmsg = PS_sendmsg..PS_NEARBY..Loc.." ["..xy.."]";
          else
            PS_sendmsg = PSvars.CustomWarning;
            if not isplayer then
              PS_sendmsg = string.gsub(PS_sendmsg, ' %%c', "");
              PS_sendmsg = string.gsub(PS_sendmsg, ' %%r', "");
            end
            PS_sendmsg = string.gsub(PS_sendmsg, '%%w', setag..setmess);
            PS_sendmsg = string.gsub(PS_sendmsg, '%%n', unitname);
            PS_sendmsg = string.gsub(PS_sendmsg, ' %%c', sclass);
            PS_sendmsg = string.gsub(PS_sendmsg, '%%l', level);
            PS_sendmsg = string.gsub(PS_sendmsg, ' %%r', srace);
            PS_sendmsg = string.gsub(PS_sendmsg, '%%x', xy);
            PS_sendmsg = string.gsub(PS_sendmsg, '%%z', Loc);
          end
          if PS_lastpinged ~= unitname then
            PS_Notification();
          end
        end
      end
      PS_cchck = nil;
      return;
    end
    if (event == "UPDATE_BATTLEFIELD_SCORE") then
      local tdl = 0;
      for i=1, GetNumBattlefieldScores()  do
        name, killingBlows, honorableKills, deaths, honorGained, faction, rank, race, class = GetBattlefieldScore(i);
        if string.find(name, "-") ~= nil then
          _, _, name = string.find(name, "(.*)-(.*)")
        end
        if PS_faction == "Alliance" then
          targetData = PS_GetFriendlyPlayer(name);
          if targetData == nil then
            targetData = PS_GetEnemyPlayer(name);
            if targetData == nil then
              targetData = PS_GetEmptyTargetEntry();
              tdl = -2;
            else
              tdl = targetData.Level;
            end
          else
             tdl = targetData.Level;
          end
        else
          targetData = PS_HordeFriendlyP(name);
          if targetData == nil then
            targetData = PS_HordeEnemyP(name);
            if targetData == nil then
              targetData = PS_GetEmptyTargetEntry();
              tdl = -2;
            else
              tdl = targetData.Level;
            end
          else
            tdl = targetData.Level;
          end
        end
        targetData.Class = class;
        targetData.Race = race;
        targetData.Level = tdl;
        targetData.IsTemp = true;
        if(targetData.Zone == "") then
          targetData.Zone = GetRealZoneText();
          targetData.SubZone = GetSubZoneText();
        end
        if((PS_faction == "Horde" and faction == 0) or (PS_faction == "Alliance" and faction == 1)) then
          PS_AddDBEntry(name, targetData, false, true, "Nil");
        else
          PS_AddDBEntry(name, targetData, true, true, "Nil");
        end
      end
    end
    if (event == "CHAT_MSG_COMBAT_HOSTILE_DEATH") then
      local name;
      for name in string.gmatch(arg1, PS_DIES) do
        PS_DeathDetect(name);
        return;
      end
      for name in string.gmatch(arg1, PS_SLAINBY) do
        PS_DeathDetect(name);
        return;
      end
      for name in string.gmatch(arg1, PS_SLAIN2) do
        PS_DeathDetect(name);
        return;
      end
    end
    if (event == "CHAT_MSG_COMBAT_FRIENDLY_DEATH") then
      local name;
      for name in string.gmatch(arg1, PS_DIES) do
        PS_DeathDetect(name);
        return;
      end
    end
    if (event == "CHAT_MSG_SYSTEM") then
      local name;
      for name in string.gmatch(arg1, PS_DIES2) do
        PS_DeathDetect(name);
        return;
      end
    end
    if (event == "CHAT_MSG_COMBAT_HONOR_GAIN") then
      local name;
      for name in string.gmatch(arg1, PS_HONOR) do
        PS_DeathDetect(name);
        return;
      end
    end
    if ((event == "UPDATE_BATTLEFIELD_SCORE") or (event == "CHAT_MSG_BG_SYSTEM_NEUTRAL")) then
      RequestBattlefieldScoreData();
      return;
    end
    if (PSvars.SentryMode and SentryCheck) then
      PS_Parse(event, arg1);
    end
  end
end

function PS_DetectStealth()

  if (PS_lastpinged == PS_cchck and not PS_skipchk) then
    return;
  end
  PS_stealth = false;
  local name = "n o";
  local sdr = "n o";
  local srg = "n o";
  local enemy = 0;
  local play = 0;
  local srace = "";
  local sclass = "";
  local setag = "";
  local setmess = "";
  if PS_faction == "Alliance" then
    targetData = PS_GetFriendlyPlayer(PS_cchck);
    if targetData == nil then
      targetData = PS_GetEnemyPlayer(PS_cchck);
      if targetData == nil then
        targetData = PS_GetEnemyMob(PS_cchck);
        if targetData == nil then
          targetData = PS_GetFriendlyMob(PS_cchck);
        else
          enemy = 1;
        end
      else
        enemy = 1;
        play = 1;
      end
    else
      play = 1;
    end
  else
    targetData = PS_HordeFriendlyP(PS_cchck);
    if targetData == nil then
      targetData = PS_HordeEnemyP(PS_cchck);
      if targetData == nil then
        targetData = PS_HordeEnemyM(PS_cchck);
        if targetData == nil then
          targetData = PS_HordeFriendlyM(PS_cchck);
        else
          enemy = 1;
        end
      else
        enemy = 1;
        play = 1;
      end
    else
      play = 1;
    end
  end
  if targetData ~= nil then
    if (UnitName("target") ~= nil or PS_skipchk) then
      name = UnitName("target");
    end
    if ((targetData.Class == PS_ROGUE or targetData.Class == PS_DRUID) or name == PS_cchck or PS_skipchk) then
      PS_stealth = true;
      PS_skipchk = false;
      if(PS_UserWantsToPing() or IsControlKeyDown()) then
        if (PS_X ~= 999 and PS_Y ~= 999) then
          Minimap:PingLocation(PS_X, PS_Y);
        end
      end
      if tonumber(targetData.Level) == -1 then
        level = (UnitLevel("player") + 10) .. "+";
      elseif tonumber(targetData.Level) == -2 then
        level = "??";
      else
        level = tonumber(targetData.Level);
      end
      if enemy == 1 then
        setag = PS_WE;
      else
        setag = PS_DF;
      end
      if play == 1 then
        setmess = PS_PLAYER;
        srace = " "..targetData.Race;
        sclass = " "..targetData.Class;
      else
        setmess = "NPC: ";
        srace = "";
        sclass = "";
      end
      Loc = GetMinimapZoneText();
      x, y = GetPlayerMapPosition("player");
      iX = math.floor(x*100);
      iY = math.floor(y*100);
      xy = iX..", "..iY;
      if PSvars.CustomWarning == "" then
        PS_sendmsg = setag..setmess..PS_cchck.." ("..level..srace..sclass..")";
        PS_sendmsg = PS_sendmsg..PS_NEARBY..Loc.." ["..xy.."]";
      else
        PS_sendmsg = PSvars.CustomWarning;
        if play == 0 then
          PS_sendmsg = string.gsub(PS_sendmsg, ' %%c', "");
          PS_sendmsg = string.gsub(PS_sendmsg, ' %%r', "");
        end
        PS_sendmsg = string.gsub(PS_sendmsg, '%%w', setag..setmess);
        PS_sendmsg = string.gsub(PS_sendmsg, '%%n', PS_cchck);
        PS_sendmsg = string.gsub(PS_sendmsg, ' %%c', sclass);
        PS_sendmsg = string.gsub(PS_sendmsg, '%%l', level);
        PS_sendmsg = string.gsub(PS_sendmsg, ' %%r', srace);
        PS_sendmsg = string.gsub(PS_sendmsg, '%%x', xy);
        PS_sendmsg = string.gsub(PS_sendmsg, '%%z', Loc);
      end
    end
    PS_Notification();
  end
end

function PS_Refresh(unitname, isplayer, isenemy, type, level, race, class, PS_id)

  if PS_id < 2 then
    return;
  end
  targetData = PS_GetUnitData(unitname);
  if isplayer then
    message = unitname.." ("..level.." "..race.." "..class..")";
    if isenemy then
      r = PSvars.EnemyPlayer.r;
      g = PSvars.EnemyPlayer.g;
      b = PSvars.EnemyPlayer.b;
      r1 = 1;
      g1 = .35;
      b1 = .35;
    else
      r = PSvars.FriendlyPlayer.r;
      g = PSvars.FriendlyPlayer.g;
      b = PSvars.FriendlyPlayer.b;
      r1 = .35;
      g1 = 1;
      b1 = .35;
    end
  else
    message = "NPC: "..unitname.." ("..level..")";
    if isenemy then
      r = PSvars.EnemyNPC.r;
      g = PSvars.EnemyNPC.g;
      b = PSvars.EnemyNPC.b;
      r1 = 1;
      g1 = .35;
      b1 = .35;
    else
      r = PSvars.FriendlyNPC.r;
      g = PSvars.FriendlyNPC.g;
      b = PSvars.FriendlyNPC.b;
      r1 = .35;
      g1 = 1;
      b1 = .35;
    end
  end
  button = getglobal("PS_PopupButton"..PS_id..PS_CombatMode..PSvars.PopupMode.."Button");
  bar = getglobal("PS_PopupButton"..PS_id..PS_CombatMode..PSvars.PopupMode.."ButtonBar");
  bg = getglobal("PS_PopupButton"..PS_id..PS_CombatMode..PSvars.PopupMode.."ButtonBGBar");
  bgtext = getglobal("PS_PopupButton"..PS_id..PS_CombatMode..PSvars.PopupMode.."ButtonBarLeftText");
  classicon = getglobal("PS_PopupButton"..PS_id..PS_CombatMode..PSvars.PopupMode.."ButtonClassIcon");
  if PS_CLASSES[targetData.Class] then
    classicon:SetTexCoord(unpack(PS_CLASSES[targetData.Class]));
  else
    classicon:SetTexCoord(0, .25, 0, .25);
  end
  classicon:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes");
  getglobal("PS_PopupButton"..PS_id..PS_CombatMode..PSvars.PopupMode):SetBackdropBorderColor(r, g, b);
  bar:SetStatusBarColor(r, g, b, 1);
  bg:SetStatusBarColor(r, g, b, .1);
  local health = UnitHealth(type);
  if PSvars.CustomPopup ~= "" then
    if targetData.Race == nil then
      message = "NPC: "..PSvars.CustomPopup;
      message = string.gsub(message, ' %%r', "");
      message = string.gsub(message, '%%r ', "");
      message = string.gsub(message, '%%r', "");
      message = string.gsub(message, ' %%c', "");
      message = string.gsub(message, '%%c ', "");
      message = string.gsub(message, '%%c', "");
    else
      message = PSvars.CustomPopup;
      message = string.gsub(message, '%%r', targetData.Race);
      message = string.gsub(message, '%%c', targetData.Class);
    end
    message = string.gsub(message, ' %%d', "");
    message = string.gsub(message, '%%d ', "");
    message = string.gsub(message, '%%d', "");
    message = string.gsub(message, '%%n', unitname);
    message = string.gsub(message, '%%l', level);
    if string.find(message, "nohealth") then
      health = 0;
      message = string.gsub(message, ' nohealth', "");
      message = string.gsub(message, 'nohealth ', "");
      message = string.gsub(message, 'nohealth', "");
    end
    if string.find(message, "%%p") then
      message = string.gsub(message, ' %%p', "");
      message = string.gsub(message, '%%p ', "");
      message = string.gsub(message, '%%p', "");
      if (targetData.Class ~= nil and targetData.Class ~= "" and targetData.Race ~= nil) then
        local colorData = popup_class_color[targetData.Class];
        r1 = colorData.r;
        g1 = colorData.g;
        b1 = colorData.b;
        bar:SetStatusBarColor(r1 - .3, g1 - .3, b1 - .3, 1);
        bg:SetStatusBarColor(r1 - .3, g1 - .3, b1 - .3, .1);
      end
    end
  end
  button:SetTextColor (r1, g1, b1);
  bar:SetValue(health);
  button:SetText(message);
  button.PS_ID = PS_id;
  button.PS_DATA = unitname;
  button:GetParent():Show();
  button:Show();
  PS_width = PS_neww;
  local w = button:GetTextWidth();
  if w > PS_width then
    PS_width = w;
    PS_neww = PS_width;
  end
  PS_Display_Popup(PS_width + 10);
  if UnitIsDeadOrGhost(type) then
    PS_DeathDetect(unitname);
  end
end

function PS_CombatSentryEvent(name, level, class, race)

  local target = nil;
  if PS_tpos < 11 then
    if (level ~= nil and class ~= nil) then
      PS_addpop = 2;
    else
      PS_addpop = 1;
    end
    PS_CSG = 1;
    PS_Process_Tooltip(name);
  end
end

function PS_Parse(event, arg1)

  if not arg1 then
    return;
  end
  local unitName, targetName, spell, spell2, damage, damtype;
  if event == "CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS" then
    for unitName, spell, spell2, targetName, damage in string.gmatch(arg1, PS_SDAM2_HIT) do
      if (targetName ~= PS_YOU) then
        damage = nil;
      end
      PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
      return;
    end
    for unitName, targetName, damage in string.gmatch(arg1, PS_SDAM_HIT) do
      if (targetName ~= PS_YOU) then
        damage = nil;
      end
      PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
      return;
    end
    for unitName, targetName, damage in string.gmatch(arg1, PS_DAM_HIT) do
      if (targetName ~= PS_YOU) then
        damage = nil;
      end
      PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1);
      return;
    end
    for unitName, spell, spell2, targetName, damage in string.gmatch(arg1, PS_SDAM2_CRIT) do
      if (targetName ~= PS_YOU) then
        damage = nil;
      end
      PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
      return;
    end
    for unitName, targetName, damage in string.gmatch(arg1, PS_SDAM_CRIT) do
      if (targetName ~= PS_YOU) then
        damage = nil;
      end
      PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
      return;
    end
    for unitName, targetName, damage in string.gmatch(arg1, PS_DAM_CRIT) do
      if (targetName ~= PS_YOU) then
        damage = nil;
      end
      PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1);
      return;
    end
    for unitName, targetName, damage in string.gmatch(arg1, arg2, PS_SDAM_MISS) do
      PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
      return;
    end
  elseif event == "CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE" then
    if (GetLocale() == "enUS") then
      for unitName, spell, spell2, targetName, damage in string.gmatch(arg1, PS_SDAM2_HIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
        return;
      end
      for unitName, spell, targetName, damage in string.gmatch(arg1, PS_SDAM_HIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
        return;
      end
      for unitName, spell, targetName in string.gmatch(arg1, PS_SDAM_DODGEBY) do
        PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
        return;
      end
      for unitName, spell, targetName in string.gmatch(arg1, PS_SDAM_EVADEBY) do
        PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
        return;
      end
    elseif (GetLocale() == "deDE") then
      for unitName, targetName, spell, spell2, damage in string.gmatch(arg1, PS_SDAM2_HIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
        return;
      end
      for unitName, targetName, spell, damage in string.gmatch(arg1, PS_SDAM_HIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
        return;
      end
      for spell, unitName, targetName in string.gmatch(arg1, PS_SDAM_DODGEBY) do
        PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
        return;
      end
      for spell, unitName, targetName in string.gmatch(arg1, PS_SDAM_EVADEBY) do
        PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
        return;
      end
    end
    for unitName, spell, spell2, targetName, damage in string.gmatch(arg1, PS_SDAM2_CRIT) do
      if (targetName ~= PS_YOU) then
        damage = nil;
      end
      PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
      return;
    end
    for unitName, spell, targetName, damage in string.gmatch(arg1, PS_SDAM_CRIT) do
      if (targetName ~= PS_YOU) then
        damage = nil;
      end
      PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1, spell);
      return;
    end
    for unitName, spell in string.gmatch(arg1, PS_SDAM_BLOCK) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1);
      return;
    end
    for unitName, spell, targetName in string.gmatch(arg1, PS_SDAM_BLOCKBY) do
      PS_CaptureAttack(unitName, targetName, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell in string.gmatch(arg1, PS_SDAM_DEFLECT) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell, targetName in string.gmatch(arg1, PS_SDAM_DEFLECTBY) do
      PS_CaptureAttack(unitName, targetName, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell in string.gmatch(arg1, PS_SDAM_DODGE) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell in string.gmatch(arg1, PS_SDAM_EVADE) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell in string.gmatch(arg1, PS_SDAM_FAIL) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell in string.gmatch(arg1, PS_SDAM_MISS) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell in string.gmatch(arg1, PS_SDAM_PARRY) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell, spell2 in string.gmatch(arg1, PS_SDAM2_RESIST) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell in string.gmatch(arg1, PS_SDAM_RESIST) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell, spell2, targetName in string.gmatch(arg1, PS_SDAM2_RESISTBY) do
      PS_CaptureAttack(unitName, targetName, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell, targetName in string.gmatch(arg1, PS_SDAM_RESISTBY) do
      PS_CaptureAttack(unitName, targetName, nil, nil, nil, 1, spell);
      return;
    end
  elseif event == "CHAT_MSG_COMBAT_HOSTILEPLAYER_MISSES" then
    for unitName, targetName in string.gmatch(arg1, PS_MISS_MISS) do
      PS_CaptureAttack(unitName, targetName, nil, nil, nil, 1);
      return;
    end
    for unitName, targetName in string.gmatch(arg1, PS_MISS_PARRY) do
      PS_CaptureAttack(unitName, targetName, nil, nil, nil, 1);
      return;
    end
    for unitName, targetName in string.gmatch(arg1, PS_MISS_EVADE) do
      PS_CaptureAttack(unitName, targetName, nil, nil, nil, 1);
      return;
    end
    for unitName, targetName in string.gmatch(arg1, PS_MISS_DODGE) do
      PS_CaptureAttack(unitName, targetName, nil, nil, nil, 1);
      return;
    end
    for unitName, targetName in string.gmatch(arg1, PS_MISS_DEFLECT) do
      PS_CaptureAttack(unitName, targetName, nil, nil, nil, 1);
      return;
    end
    for unitName, targetName in string.gmatch(arg1, PS_MISS_BLOCK) do
      PS_CaptureAttack(unitName, targetName, nil, nil, nil, 1);
      return;
    end
    for unitName, targetName, damage in string.gmatch(arg1, PS_MISS_ABSORB) do
      if (targetName ~= PS_YOU) then
        damage = nil;
      end
      PS_CaptureAttack(unitName, targetName, damage, nil, nil, 1);
      return;
    end
  elseif (event == "CHAT_MSG_SPELL_HOSTILEPLAYER_BUFF" or event == "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_BUFFS") then
    for unitName, spell in string.gmatch(arg1, PS_SPLL_DRAIN) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell, targetName, damage in string.gmatch(arg1, PS_SPLL_HEALCRIT) do
      if (not targetName or unitName == targetName or string.gmatch(targetName, unitName)) then
        PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
        return;
      else
        PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
        PS_CaptureAttack(targetName, nil, nil, nil, nil, 1, spell);
        return;
      end
      return;
    end
    for unitName, spell, targetName, damage in string.gmatch(arg1, PS_SPLL_HEAL) do
      if (not targetName or unitName == targetName or string.gmatch(targetName, unitName)) then
        PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
        return;
      else
        PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
        PS_CaptureAttack(targetName, nil, nil, nil, nil, 1, spell);
        return;
      end
      return;
    end
    for unitName, spell, targetName in string.gmatch(arg1, PS_SPLL_CAST) do
      if (not targetName or unitName == targetName or string.gmatch(targetName, unitName)) then
        PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
        return;
      else
        PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
        PS_CaptureAttack(targetName, nil, nil, nil, nil, 1, spell);
        return;
      end
      return;
    end
    for unitName, spell, targetName in string.gmatch(arg1, PS_SPLL_CASTS) do
      if (not targetName or unitName == targetName or string.gmatch(targetName, unitName)) then
        PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
        return;
      else
        PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
        PS_CaptureAttack(targetName, nil, nil, nil, nil, 1, spell);
        return;
      end
      return;
    end
    for unitName, spell in string.gmatch(arg1, PS_SPLL_CASTS2) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell in string.gmatch(arg1, PS_SPLL_GAINS) do
      if (spell and PS_AbilityList[spell] and PS_AbilityList[spell].ob) then
        PS_CaptureAttack(unitName, nil, nil, nil, nil, 1);
      else
        PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
      end
      return;
    end
    for unitName in string.gmatch(arg1, PS_SPLL_GAINS2) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1);
      return;
    end
    for unitName, spell in string.gmatch(arg1, PS_SPLL_BPERFORM) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
      return;
    end
    for unitName, spell in string.gmatch(arg1, PS_SPLL_BCAST) do
      PS_CaptureAttack(unitName, nil, nil, nil, nil, 1, spell);
      return;
    end
    elseif (event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE") then
      for damage, damtype, unitName in string.gmatch(arg1, PS_SDAM_SUFFER) do
        PS_CaptureAttack(unitName, targetName, damage, "DoT");
        return;
      end
  elseif (PSvars.tracking == "ENEMIES" or PSvars.tracking == "ALL") then
    if (event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS") then
      for unitName, targetName, damage in string.gmatch(arg1, PS_SDAM2_HIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99, 1);
        return;
      end
      for unitName, targetName, damage in string.gmatch(arg1, PS_SDAM_HIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99, 1);
        return;
      end
      for unitName, targetName, damage in string.gmatch(arg1, PS_DAM_HIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99, 1);
        return;
      end
      for unitName, targetName, damage in string.gmatch(arg1, PS_SDAM2_CRIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99, 1);
        return;
      end
      for unitName, targetName, damage in string.gmatch(arg1, PS_SDAM_CRIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99, 1);
        return;
      end
      for unitName, targetName, damage in string.gmatch(arg1, PS_DAM_CRIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99, 1);
        return;
      end
    elseif (event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE") then
      for unitName, spell, spell2, targetName, damage in string.gmatch(arg1, PS_SDAM2_HIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99);
        return;
      end
      for unitName, spell, targetName, damage in string.gmatch(arg1, PS_SDAM2_HIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99);
        return;
      end
      for unitName, spell, targetName, damage in string.gmatch(arg1, PS_SDAM_HIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99);
        return;
      end
      for unitName, spell, targetName, damage in string.gmatch(arg1, PS_DAM_HIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99);
        return;
      end
      for unitName, spell, spell2, targetName, damage in string.gmatch(arg1, PS_SDAM2_CRIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99);
        return;
      end
      for unitName, spell, targetName, damage in string.gmatch(arg1, PS_SDAM_CRIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99);
        return;
      end
      for unitName, spell, targetName, damage in string.gmatch(arg1, PS_DAM_CRIT) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99);
        return;
      end
      for unitName, spell in string.gmatch(arg1, PS_SDAM_BLOCK) do
        PS_CaptureAttack(unitName, nil, nil, nil, 99);
        return;
      end
      for unitName, spell in string.gmatch(arg1, PS_SDAM_DEFLECT) do
        PS_CaptureAttack(unitName, nil, nil, nil, 99);
        return;
      end
      for unitName, spell in string.gmatch(arg1, PS_SDAM_DODGE) do
        PS_CaptureAttack(unitName, nil, nil, nil, 99);
        return;
      end
      for unitName, spell in string.gmatch(arg1, PS_SDAM_EVADE) do
        PS_CaptureAttack(unitName, nil, nil, nil, 99);
        return;
      end
      for unitName, spell in string.gmatch(arg1, PS_SDAM_FAIL) do
        PS_CaptureAttack(unitName, nil, nil, nil, 99);
        return;
      end
      for unitName, spell in string.gmatch(arg1, PS_SDAM_MISS) do
        PS_CaptureAttack(unitName, nil, nil, nil, 99);
        return;
      end
      for unitName, spell in string.gmatch(arg1, PS_SDAM_PARRY) do
        PS_CaptureAttack(unitName, nil, nil, nil, 99);
        return;
      end
      for unitName, spell in string.gmatch(arg1, PS_SDAM_RESIST) do
        PS_CaptureAttack(unitName, nil, nil, nil, 99);
        return;
      end
    elseif (event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_MISSES" or event == "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_MISSES") then
      for unitName, targetName in string.gmatch(arg1, PS_MISS_MISS) do
        PS_CaptureAttack(unitName, targetName, nil, nil, 99, 1);
        return;
      end
      for unitName, targetName in string.gmatch(arg1, PS_MISS_PARRY) do
        PS_CaptureAttack(unitName, targetName, nil, nil, 99);
        return;
      end
      for unitName, targetName in string.gmatch(arg1, PS_MISS_EVADE) do
        PS_CaptureAttack(unitName, targetName, nil, nil, 99);
        return;
      end
      for unitName, targetName in string.gmatch(arg1, PS_MISS_DODGE) do
        PS_CaptureAttack(unitName, targetName, nil, nil, 99);
        return;
      end
      for unitName, targetName in string.gmatch(arg1, PS_MISS_DEFLECT) do
        PS_CaptureAttack(unitName, targetName, nil, nil, 99);
        return;
      end
      for unitName, targetName in string.gmatch(arg1, PS_MISS_BLOCK) do
        PS_CaptureAttack(unitName, targetName, nil, nil, 99);
        return;
      end
      for unitName, targetName, damage in string.gmatch(arg1, PS_MISS_ABSORB) do
        if (targetName ~= PS_YOU) then
          damage = nil;
        end
        PS_CaptureAttack(unitName, targetName, damage, nil, 99);
        return;
      end
    elseif (event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_BUFF" or event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF") then
      for unitName, spell, targetName, damage in string.gmatch(arg1, CSG_SPLL_HEALCRIT) do
        if (unitName == targetName) then
          return;
        else
          if targetName == PS_YOU then
            return;
          end
          PS_CaptureAttack(unitName, targetName, damage, nil, 99);
          return;
        end
      end
      for unitName, spell, targetName, damage in string.gmatch(arg1, CSG_SPLL_HEAL) do
        if (unitName == targetName) then
          return;
        else
          if targetName == PS_YOU then
            return;
          end
          PS_CaptureAttack(unitName, targetName, damage, nil, 99);
          return;
        end
      end
      for unitName, spell, targetName in string.gmatch(arg1, CSG_SPLL_CAST) do
        if (unitName == targetName) then
          return;
        else
          if targetName == PS_YOU then
            return;
          end
          PS_CaptureAttack(unitName, targetName, damage, nil, 99);
          return;
        end
      end
      for unitName, spell, targetName in string.gmatch(arg1, CSG_SPLL_CASTS) do
        if (unitName == targetName) then
          return;
        else
          if targetName == PS_YOU then
            return;
          end
          PS_CaptureAttack(unitName, targetName, damage, nil, 99);
          return;
        end
      end
    end
  end
end

function PS_CaptureAttack(unitName, targetName, damage, type, skipcheck, pvp, spell)

  local lvl = nil;
  local cls = nil;
  local race = nil;
  local isenemy = nil;
  local isplayer = nil;
  local listData = PS_GetListData(unitName);
  PSvars.party = {};
  PSvars.partypet = {};
  if unitName == UnitName("pet") then
    return;
  end
  if type == "DoT" then
    type = nil;
    if listData.pos < 2 then
      return;
    end
  end
  if type == nil then
    if string.find(unitName, " Totem") then
      return;
    end
    if string.find(unitName, " Trap") then
      return;
    end
  end
  for i=1, GetNumPartyMembers(), 1 do
    PSvars.party[i] = UnitName("party"..i);
    PSvars.partypet[i] = UnitName("partypet"..i);
    if (unitName == PSvars.party[i] or unitName == PSvars.partypet[i]) then
      return;
    end
  end
  if (PS_tpos < 11 and type ~= nil) then
    lvl = UnitLevel(type);
    cls = UnitClass(type);
    race = UnitRace(type);
    if type == "mouseover" then
      local faction = UnitFactionGroup("mouseover");
      isenemy = UnitIsEnemy("mouseover", "player");
      isplayer = UnitIsPlayer("mouseover");
      local targetData = PS_GetUnitData(unitName);
      targetData.Class = cls;
      targetData.Race = race;
      targetData.Level = lvl;
      targetData.IsTemp = PS_bgmode;
      targetData.Zone = GetRealZoneText();
      targetData.SubZone = GetSubZoneText();
      if tonumber(lvl) == -1 then
        lvl = (UnitLevel("player") + 10) .. "+";
      end
      if tonumber(lvl) == -2 then
        lvl = "??";
      end
      if((PSvars.storage == "PLAYERS" and not isplayer) or (PSvars.storage == "NPC" and isplayer) or PSvars.storage == "NONE") then
        targetData.IsTemp = true;
      end
      PS_AddDBEntry(unitName, targetData, isenemy, isplayer, faction);
      if PS_FromMouse then
        PS_FromMouse = false;
        PS_Refresh(unitName, isplayer, isenemy, "mouseover", lvl, race, cls, listData.pos);
      end
      if ((PSvars.tracking == "ENEMY PLAYERS" and (not isplayer or not isenemy)) or (PSvars.tracking == "ALL PLAYERS" and not isplayer) or (PSvars.tracking == "ENEMIES" and not isenemy)) then
        PS_Clear_Popup();
        PS_addpop = 0;
        local thelist = PS_thelist;
        PS_thelist = "";
        PS_KeepDamage(thelist);
        PS_Process_Tooltip(thelist);
        return;
      end
    end
    PS_CombatSentryEvent(unitName, lvl, cls, race);
  elseif PS_tpos < 11 then
    if PS_faction == "Alliance" then
      targetData = PS_GetEnemyPlayer(unitName);
      if targetData == nil then
        targetData = PS_GetEnemyMob(unitName);
      end
    else
      targetData = PS_HordeEnemyP(unitName);
      if targetData == nil then
        targetData = PS_HordeEnemyM(unitName);
      end
    end
    if targetData ~= nil then
      lvl = targetData.Level;
      cls = targetData.Class;
      race = targetData.Race;
    end
    if listData.pos < 2 then
      PS_CombatSentryEvent(unitName, lvl, cls, race);
    end
  end
  local listData = PS_GetListData(unitName);
  if listData.pos > 1 then
    listData.phase = .5;
    listData.time = GetTime();
    if (string.find(PSvars.CustomPopup, "%%d") and damage ~= nil) then
      if (listData.damage == 0 or listData.damage == "HITLIST") then
        listData.damage = damage;
      else
        listData.damage = listData.damage + damage;
      end
    end
    PSvars.list[unitName] = listData;
    getglobal("PS_PopupButton"..listData.pos..PS_CombatMode..PSvars.PopupMode.."ButtonBar"):SetAlpha(listData.phase);
  end
end

function PS_DeathDetect(name)

  if not PSvars.DeathDetect then
    return;
  end
  if PS_DeathName == "nil" then
    PS_DeathTime = GetTime();
    PS_DeathName = name.."\n";
  else
    for target in string.gmatch(PS_DeathName,"[^\n]*") do
      if string.len(target) > 0 then
        if target == name then
          return;
        end
      end
    end
    PS_DeathTime = GetTime();
    PS_DeathName = PS_DeathName..name.."\n";
  end
end

function PS_DeathDetect2(name)

  PS_DeathTime = nil;
  PS_DeathName = "nil";
  local templist = "";
  for target in string.gmatch(PS_thelist, "[^\n]*") do
    if string.len(target) > 0 then
      if target ~= name then
        templist = templist..target.."\n";
      else
        if (target == UnitName("target") and not UnitIsDeadOrGhost("target")) then
          return;
        else
          listData = PS_GetListData(target);
          listData.phase = 0;
          listData.time = 0;
          listData.pos = 0;
          listData.damage = 0;
          listData.health = 0;
          PSvars.list[target] = listData;
        end
      end
    end
  end
  PS_thelist = templist;
  PS_Clear_Popup();
  PS_dim = 1;
  PS_Process_Tooltip(PS_thelist);
end

function PS_UserWantsToPing()

  if not PSvars.tracker then
    return false;
  end
  if PSvars.PingMode == "DEFAULT" then
    return true;
  end
  if (PSvars.PingMode == "OUTSIDE BG" and not PS_ZoneIsABG(GetRealZoneText())) then
    return true;
  end
  if (PSvars.PingMode == "INSIDE BG" and PS_ZoneIsABG(GetRealZoneText())) then
    return true;
  end
  return false;
end

function PS_LoadSavedVariables()

  if not PSvars then
    PSvars = {};
    PSvars.storage = "ALL";
    PSvars.announce = "AUTO";
    PSvars.DBVersion = 3;
    PSvars.MiniIcon = true;
    PSvars.Locked = false;
    PSvars.BGMode = true;
    PSvars.MinimapIconPos = 45;
    PSvars.ColorMode = "CLASS";
    PSvars.PopupMode = "DOWNWARD";
    PSvars.PingMode = "DEFAULT";
    PSvars.SentryMode = true;
    PSvars.SetTime = 30;
    PSvars.Addons = "ON";
    PSvars.tracker = false;
    PSvars.SentrySound = true;
    PSvars.SentryChk = false;
    PSvars.CustomWarning = "";
    PSvars.CustomPopup = "";
    PSvars.DeathDetect = true;
  end
  if PSvars.DownT == nil then
    PSvars.DownT = 300;
    PSvars.DownL = 300;
  end
  if PSvars.UpT == nil then
    PSvars.UpT = 300;
    PSvars.UpL = 300;
  end
  if PS_mapsend == 0 then
    PS_PopupDOWNWARD:ClearAllPoints();
    PS_PopupUPWARD:ClearAllPoints();
    PS_PopupDOWNWARD:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", PSvars.DownL, PSvars.DownT);
    PS_PopupUPWARD:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", PSvars.UpL, PSvars.UpT);
  end
  if PS_faction == "Alliance" then
    if not PSvars.EnemyMobs then
      PSvars.EnemyMobs = {};
    end
    if not PSvars.FriendlyMobs then
      PSvars.FriendlyMobs = {};
    end
    if not PSvars.EnemyPlayers then
      PSvars.EnemyPlayers = {};
    end
    if not PSvars.FriendlyPlayers then
      PSvars.FriendlyPlayers = {};
    end
  else
    if not PSvars.EnemyM then
      PSvars.EnemyM = {};
    end
    if not PSvars.FriendlyM then
      PSvars.FriendlyM = {};
    end
    if not PSvars.EnemyP then
      PSvars.EnemyP = {};
    end
    if not PSvars.FriendlyP then
      PSvars.FriendlyP = {};
    end
  end
  if PSvars.DeathDetect == nil then
    PSvars.DeathDetect = true;
  end
  if PSvars.CustomWarning == nil then
    PSvars.CustomWarning = "";
  end
  if PSvars.CustomPopup == nil then
    PSvars.CustomPopup = "";
  end
  if PS_mapsend ~= 1 then
    PSvars.list = {};
  end
  PS_mapsend = 0;
  if PSvars.scale == nil then
    PSvars.scale = 1;
  end
  if PSvars.PopupMode == nil then
    PSvars.PopupMode = "DOWNWARD";
  end
  if PSvars.MinimapIconPos == nil then
    PSvars.MinimapIconPos = 45;
  end
  if PSvars.ColorMode == nil then
    PSvars.ColorMode = "CLASS";
  end
  if PSvars.storage == nil then
    PSvars.storage = "ALL";
  end
  if PSvars.announce == nil then
    PSvars.announce = "SAY";
  end
  if PSvars.announce == "GROUP" then
    PSvars.announce = "PARTY";
  end
  if PSvars.MiniIcon == nil then
    PSvars.MiniIcon = true;
  end
  if PSvars.Locked == nil then
    PSvars.Locked = false;
  end
  if PSvars.BGMode == nil then
    PSvars.BGMode = true;
  end
  if PSvars.PingMode == nil then
    PSvars.PingMode = "DEFAULT";
  end
  if PSvars.SentryMode == nil then
    PSvars.SentryMode = true;
  end
  if PSvars.SetTime == nil then
    PSvars.SetTime = 30;
  end
  if PSvars.Addons == nil then
    PSvars.Addons = "ON";
  end
  if PSvars.SentrySound == nil then
    PSvars.SentrySound = true;
  end
  if PSvars.SentryChk == nil then
    PSvars.SentryChk = false;
  end
  local playerClass, englishClass = UnitClass("player");
  if (englishClass == "HUNTER" or englishClass == "DRUID" or englishClass == "WARLOCK") then
    PSvars.tracker = true;
  else
    PSvars.tracker = false;
  end
  if PSvars.tracking == nil then
    PSvars.tracking = "ALL";
  end
  if PSvars.EnemyPlayer == nil then
    PSvars.EnemyPlayer = {};
    PSvars.EnemyPlayer.r = 1;
    PSvars.EnemyPlayer.g = 0;
    PSvars.EnemyPlayer.b = 0;
    PSvars.EnemyNPC = {};
    PSvars.EnemyNPC.r = 1;
    PSvars.EnemyNPC.g = .3;
    PSvars.EnemyNPC.b = .3;
    PSvars.FriendlyPlayer = {};
    PSvars.FriendlyPlayer.r = 0;
    PSvars.FriendlyPlayer.g = 1;
    PSvars.FriendlyPlayer.b = 0;
    PSvars.FriendlyNPC = {};
    PSvars.FriendlyNPC.r = .3;
    PSvars.FriendlyNPC.g = 1;
    PSvars.FriendlyNPC.b = .3;
    PSvars.UNKPlayer = {};
    PSvars.UNKPlayer.r = 1;
    PSvars.UNKPlayer.g = .95;
    PSvars.UNKPlayer.b = .37;
    PSvars.UNKNPC = {};
    PSvars.UNKNPC.r = .8;
    PSvars.UNKNPC.g = .75;
    PSvars.UNKNPC.b = .3;
  end
end

function PS_ZoneIsABG(zone)
  if (zone == "Arathi Basin" or zone == "Alterac Valley" or zone == "Warsong Gulch" or zone == "Eye of the Storm") then
    return true;
  else
    return false;
  end
end

function PS_PurgeTempEntries()

  local purged = 0;
  if PS_faction == "Alliance" then
    for name, data in pairs(PSvars.EnemyPlayers) do
      local KOS = false;
      if data.IsKOS ~= nil then
        if data.IsKOS == true then
          KOS = true;
        end
        if (data.IsTemp and not KOS) then
          PSvars.EnemyPlayers[name] = nil;
          purged = purged + 1
        end
      end
    end
    for name, data in pairs(PSvars.FriendlyPlayers) do
      if data.IsTemp then
        PSvars.FriendlyPlayers[name] = nil;
        purged = purged + 1
      end
    end
    for name, data in pairs(PSvars.EnemyMobs) do
      if data.IsTemp then
        PSvars.EnemyMobs[name] = nil;
        purged = purged + 1
      end
    end
    for name, data in pairs(PSvars.FriendlyMobs) do
      if data.IsTemp then
        PSvars.FriendlyMobs[name] = nil;
        purged = purged + 1
      end
    end
  else
    for name, data in pairs(PSvars.EnemyP) do
      local KOS = false;
      if data.IsKOS ~= nil then
        if data.IsKOS == true then
          KOS = true;
        end
        if (data.IsTemp and not KOS) then
          PSvars.EnemyP[name] = nil;
          purged = purged + 1
        end
      end
    end
    for name, data in pairs(PSvars.FriendlyP) do
      if data.IsTemp then
        PSvars.FriendlyP[name] = nil;
        purged = purged + 1
      end
    end
    for name, data in pairs(PSvars.EnemyM) do
      if data.IsTemp then
        PSvars.EnemyM[name] = nil;
        purged = purged + 1
      end
    end
    for name, data in pairs(PSvars.FriendlyM) do
      if data.IsTemp then
        PSvars.FriendlyM[name] = nil;
        purged = purged + 1
      end
    end
    DEFAULT_CHAT_FRAME:AddMessage("Personal Sentry has purged "..purged.." temporary entries.", 1, 1 ,1);
  end
end

function PS_ButtonClick()

  local target = nil;
  local data = this.PS_DATA;
  PS_cchck = nil;
  PS_id = this.PS_ID;
  PS_X = tonumber(this.PS_X);
  PS_Y = tonumber(this.PS_Y);
  if (arg1 == "RightButton" and PS_id ~= 1) then
    if (IsShiftKeyDown()) then
      PS_skipchk = true;
    end
    PS_cchck = data;
    PS_DetectStealth();
  end
  if PS_id ~= 1 then
    if (arg1 == "LeftButton" and IsShiftKeyDown()) then
      if PS_faction == "Alliance" then
        target = PS_GetEnemyPlayer(data);
      else
        target = PS_HordeEnemyP(data);
      end
      if target ~= nil then
        targetData = PS_GetUnitData(data);
        if not targetData.IsKOS then
          targetData.IsKOS = true;
          if PS_faction == "Alliance" then
            PSvars.EnemyPlayers[data] = targetData;
          else
            PSvars.EnemyP[data] = targetData;
          end
          local listData = PS_GetListData(data);
          if listData ~= nil then
            if listData.damage == 0 then
              listData.damage = "HITLIST";
              PSvars.list[data] = listData;
            end
          end
          DEFAULT_CHAT_FRAME:AddMessage(data..PS_AHL, 1, .3, .6);
          if PSvars.SentrySound then
            PlaySoundFile("Interface\\AddOns\\Personal Sentry\\sounds\\hitadd.wav");
          end
        else
          targetData.IsKOS = false;
          if PS_faction == "Alliance" then
            PSvars.EnemyPlayers[data] = targetData;
          else
            PSvars.EnemyP[data] = targetData;
          end
          local listData = PS_GetListData(data);
          if listData ~= nil then
            if listData.damage == "HITLIST" then
              listData.damage = 0;
              PSvars.list[data] = listData;
            end
          end
          DEFAULT_CHAT_FRAME:AddMessage(data..PS_RHL, .3, 1, .6);
          if PSvars.SentrySound then
            PlaySoundFile("Interface\\AddOns\\Personal Sentry\\sounds\\hitremove.wav");
          end
        end
      end
    end
    this:SetAttribute("type", "macro");
    this:SetAttribute("macrotext", "/target "..data);
  else
    PS_Clear_Popup();
    PS_thelist = "";
    PSvars.list = {};
  end
end

function PS_DamButtonClick()

  local data = this.id;
  if data ~= nil then
    for target in string.gmatch(PS_thelist, "[^\n]*") do
      if string.len(target) > 0 then
        local listData = PS_GetListData(target);
        local targetData = PS_GetUnitData(target);
        if listData.pos == data then
          if targetData.IsKOS then
            listData.damage = "HITLIST";
          else
            listData.damage = 0;
            local button = getglobal("PS_PopupButton"..listData.pos..PS_CombatMode.."Dam"..PSvars.PopupMode.."Button");
            button:SetText("");
            button:GetParent():Show();
            button:Show();
          end
        end
      end
    end
  end
end

function PS_Notification()

  if PS_cchck == nil then
    return;
  else
    if (PS_cchck == UnitName("target") or PS_stealth) then
      PS_lastpinged = PS_cchck;
      if PS_cchck == UnitName("target") then
        PS_cchck = nil;
      end
      if PSvars.announce == "LOCALDEFENSE" then
        if PS_faction == "Alliance" then
		  local speak = "Common";
		else
		  local speak = "Orcish";
		end
        local placecheck = {GetMapZones(GetCurrentMapContinent())};
        local place = placecheck[GetCurrentMapZone()];
        if place ~= nil then
          defchan = GetChannelName(PS_LD.." - "..place);
        else
          place = GetMinimapZoneText();
          defchan = GetChannelName(PS_LD.." - "..place);
        end
        SendChatMessage(PS_sendmsg,"CHANNEL", speak, defchan);
        if (GetNumPartyMembers() > 0 and not PS_bgmode) then
          SendChatMessage(PS_sendmsg, "PARTY");
        end
      else
        if(PSvars.announce ~= "SELF" and PSvars.announce ~= "OFF") then
          if(PSvars.announce ~= "RAID" and PSvars.announce ~= "AUTO") then
            if PSvars.announce == "PARTY" then
              SendChatMessage(PS_sendmsg, "PARTY");
            else
              SendChatMessage(PS_sendmsg, PSvars.announce);
            end
          else
            if(GetNumRaidMembers() > 0 and not PS_bgmode) then
              SendChatMessage(PS_sendmsg, "RAID");
            elseif (GetNumPartyMembers() > 0 and not PS_bgmode) then
              SendChatMessage(PS_sendmsg, "PARTY");
            else
              SendChatMessage(PS_sendmsg, "SAY");
            end
          end
        elseif PSvars.announce == "SELF" then
          DEFAULT_CHAT_FRAME:AddMessage(PS_sendmsg, 1, 1, 1);
        end
      end
    end
  end
end

function PS_PreParseNames(names)

  if not PSvars.tracker then
    return names;
  end
  local ret = "";
  if(names == nil) then
    return;
  end
  local wasreturn = false;
  for target in string.gmatch(names, "[^\n]*") do
    if string.len(target) > 0 then
      ret = ret..PS_ColorizeTooltipText(target);
      wasreturn = false;
	else
      if not wasreturn then
        ret = ret.."\n";
        wasreturn = true;
      end
    end
  end
  return ret;
end

function PS_ColorizeTooltipText(target)

  local color = "";
  local class_color = "";
  if PS_faction == "Alliance" then
    targetData = PS_GetFriendlyPlayer(target);
    if targetData == nil then
      targetData = PS_GetEnemyPlayer(target);
      if targetData == nil then
        targetData = PS_GetEnemyMob(target);
        if targetData == nil then
          targetData = PS_GetFriendlyMob(target);
          if targetData == nil then
            targetData = PS_GetEmptyTargetEntry();
            color = PSvars.UNKPlayer;
          else
            color = PSvars.FriendlyNPC;
          end
        else
          color = PSvars.EnemyNPC;
        end
      else
        color = PSvars.EnemyPlayer;
      end
    else
      color = PSvars.FriendlyPlayer;
    end
  else
    targetData = PS_HordeFriendlyP(target);
    if targetData == nil then
      targetData = PS_HordeEnemyP(target);
      if targetData == nil then
        targetData = PS_HordeEnemyM(target);
        if targetData == nil then
          targetData = PS_HordeFriendlyM(target);
          if targetData == nil then
            targetData = PS_GetEmptyTargetEntry();
            color = PSvars.UNKPlayer;
          else
            color = PSvars.FriendlyNPC;
          end
        else
          color = PSvars.EnemyNPC;
        end
      else
        color = PSvars.EnemyPlayer;
      end
    else
      color = PSvars.FriendlyPlayer;
    end
  end
  return '|c'..PS_GetHexColor(color)..target..'|r'..PS_GetClassColor(targetData);
end

function PS_GetHexColor(color)

  local rh = string.format("%x", color.r * 255);
  local gh = string.format("%x", color.g * 255);
  local bh = string.format("%x", color.b * 255);
  if string.len(rh) == 1 then
    rh = "0"..rh;
  end
  if string.len(gh) == 1 then
    gh = "0"..gh;
  end
  if string.len(bh) == 1 then
    bh = "0"..bh;
  end
  return "ff"..rh..gh..bh;
end

function PS_GetClassColor(data)

  local ret = "";
  if PSvars.ColorMode == "NORMAL" then
    return "";
  end
  if(data == nil or data.Class == nil or tooltip_class_color[data.Class] == nil) then
    return "";
  end
  if(PSvars.ColorMode ~= "CLASS LEVEL" or data.Level == nil or tonumber(data.Level) < 1) then
    return '|c'..tooltip_class_color[data.Class].." ["..data.Class..']|r'
  else
    return '|c'..tooltip_class_color[data.Class].." ["..data.Level.." "..data.Class..']|r'
  end
end

function PS_Minimap_OnClick_Event()

  if (PSvars.tracker and (PSvars.Addons == "ON" or (PSvars.Addons == "BG" and PS_bgmode))) then
    if(IsControlKeyDown()) then
      lOriginal_Minimap_OnClick_Event();
    else
      if GameTooltip:IsVisible() then
        PS_starttime = GetTime();
        PS_mocheck = 3;
        local x, y = GetCursorPosition();
        x = x / Minimap:GetEffectiveScale();
        y = y / Minimap:GetEffectiveScale();
        local cx, cy = Minimap:GetCenter();
        PS_X = x + CURSOR_OFFSET_X - cx;
        PS_Y = y + CURSOR_OFFSET_Y - cy;
        if (arg1 == "LeftButton") then
          PS_Clear_Popup();
          PS_thelist = "";
          PSvars.list = {};
          PS_addpop = 0;
          PS_MMT = true;
          PS_Process_Tooltip(GameTooltipTextLeft1:GetText());
        else
          if PS_tpos < 11 then
            PS_addpop = 1;
            PS_MMT = true;
            PS_Process_Tooltip(GameTooltipTextLeft1:GetText());
          end
        end
      end
    end
  else
    lOriginal_Minimap_OnClick_Event();
  end
end

function PS_MOCE2()

  if GameTooltip:IsVisible() then
    PS_mocheck = 0;
    if (IsShiftKeyDown()) then
      PS_addpop = 1;
    else
      PS_addpop = 0;
    end
    if PS_tpos < 11 then
      PS_MMT = true;
      PS_Process_Tooltip(GameTooltipTextLeft1:GetText());
    end
  end
end

function PS_CompareTooltip(tooltip)

  if PS_dim == 1 then
    PS_dim = 0;
    return PS_thelist;
  end
  PSvars.compare = {};
  PS_newline = "";
  local tcount = 1;
  if (PS_addpop > 0 and PS_tpos > 1) then
    tcount = PS_tpos;
  end
  for target in string.gmatch(tooltip, "[^\n]*") do
    local good = false;
    target = PS_Process_Trg(target);
    if(string.len(target) > 0 and tcount < 11) then
      local listData = PS_GetListData(target);
      local compareData = PS_GetCompareData(target);
      if (PS_addpop == 2 and listData.pos > 1) then
        listData.phase = .5;
        listData.time = GetTime();
        PSvars.list[target] = listData;
      end
      if PSvars.tracking == "ALL" then
        good = true;
      elseif PSvars.tracking == "ENEMY PLAYERS" then
        if PS_faction == "Alliance" then
          targetData = PS_GetFriendlyPlayer(target);
          if targetData == nil then
            targetData = PS_GetEnemyPlayer(target);
            if targetData == nil then
              targetData = PS_GetEnemyMob(target);
              if targetData == nil then
                targetData = PS_GetFriendlyMob(target);
                if targetData == nil then
                  good = true;
                end
              end
            else
              good = true;
            end
          end
        else
          targetData = PS_HordeFriendlyP(target);
          if targetData == nil then
            targetData = PS_HordeEnemyP(target);
            if targetData == nil then
              targetData = PS_HordeEnemyM(target);
              if targetData == nil then
                targetData = PS_HordeFriendlyM(target);
                if targetData == nil then
                  good = true;
                end
              end
            else
              good = true;
            end
          end
        end
      elseif PSvars.tracking == "ENEMIES" then
        if PS_faction == "Alliance" then
          targetData = PS_GetFriendlyPlayer(target);
          if targetData == nil then
            targetData = PS_GetEnemyPlayer(target);
            if targetData == nil then
              targetData = PS_GetEnemyMob(target);
              if targetData == nil then
                targetData = PS_GetFriendlyMob(target);
                if targetData == nil then
                  good = true;
                end
              else
                good = true;
              end
            else
              good = true;
            end
          end
        else
          targetData = PS_HordeFriendlyP(target);
          if targetData == nil then
            targetData = PS_HordeEnemyP(target);
            if targetData == nil then
              targetData = PS_HordeEnemyM(target);
              if targetData == nil then
                targetData = PS_HordeFriendlyM(target);
                if targetData == nil then
                  good = true;
                end
              else
                good = true;
              end
            else
              good = true;
            end
          end
        end
      elseif PSvars.tracking == "ALL PLAYERS" then
        if PS_faction == "Alliance" then
          targetData = PS_GetFriendlyPlayer(target);
          if targetData == nil then
            targetData = PS_GetEnemyPlayer(target);
            if targetData == nil then
              targetData = PS_GetEnemyMob(target);
              if targetData == nil then
                targetData = PS_GetFriendlyMob(target);
                if targetData == nil then
                  good = true;
                end
              end
            else
              good = true;
            end
          else
            good = true;
          end
        else
          targetData = PS_HordeFriendlyP(target);
          if targetData == nil then
            targetData = PS_HordeEnemyP(target);
            if targetData == nil then
              targetData = PS_HordeEnemyM(target);
              if targetData == nil then
                targetData = PS_HordeFriendlyM(target);
                if targetData == nil then
                  good = true;
                end
              end
            else
              good = true;
            end
          else
            good = true;
          end
        end
      end
      if (compareData.listed ~= 1 and good) then
        if (listData.pos < 2 and tcount < 11) then
          PS_newline = PS_newline..target.."\n";
          compareData.listed = 1;
          PSvars.compare[target] = compareData;
          tcount = tcount + 1;
        end
      elseif (compareData.listed ~= 1 and not good) then
        listData.pos = 0;
        listData.damage = 0;
        listData.health = 0;
        listData.time = 0;
        listData.phase = 0;
        PSvars.list[target] = listData;
      end
    end
  end
  if (PS_addpop > 0 or (PS_bgmode and PSvars.BGMode)) then
    PS_thelist = PS_thelist..PS_newline;
  else
    PS_thelist = PS_newline;
  end
    return PS_newline;
end

function PS_Process_Tooltip(tooltip, silent)

  local pos = 0;
  PS_width = 0;
  if (PS_addpop > 0 or (PS_bgmode and PSvars.BGMode)) then
     pos = PS_tpos;
     PS_width = PS_neww;
  end
  local result_line, r, g, b, target, class, health, rank;
  local prev_trg = nil;
  local targetData = nil;
  local listData = nil;
  if ((PS_tpos > 1 and PS_tpos < 11) or PS_tpos == 0) then
    PS_line = PS_CompareTooltip(tooltip);
  end
  if pos == 0 then
    pos = 1;
    message = "Clear Targets";
    local button = getglobal("PS_PopupButton"..pos..PS_CombatMode..PSvars.PopupMode.."Button");
    local bar = getglobal("PS_PopupButton"..pos..PS_CombatMode..PSvars.PopupMode.."ButtonBar");
    local bg = getglobal("PS_PopupButton"..pos..PS_CombatMode..PSvars.PopupMode.."ButtonBGBar");
    local bgtext = getglobal("PS_PopupButton"..pos..PS_CombatMode..PSvars.PopupMode.."ButtonBarLeftText");
    local classicon = getglobal("PS_PopupButton"..pos..PS_CombatMode..PSvars.PopupMode.."ButtonClassIcon");
    if PSvars.Locked then
      classicon:SetTexture("Interface\\AddOns\\Personal Sentry\\Images\\locked");
    else
      classicon:SetTexture("Interface\\AddOns\\Personal Sentry\\Images\\unlocked");
    end
    r = .25;
    g = .25;
    b = 1;
    getglobal("PS_PopupButton"..pos..PS_CombatMode..PSvars.PopupMode):SetBackdropBorderColor(r, g, b);
    bar:SetStatusBarColor(r, g, b, .75);
    bar:SetValue(100);
    bg:SetStatusBarColor(r, g, b, 0.1);
    button:SetTextColor (.75, .75, 1);
    button:SetText(message);
    button.PS_ID = pos;
    button.PS_DATA = hsdata;
    button:GetParent():Show();
    button:Show();
    local w = button:GetTextWidth();
    if w > PS_width then
      PS_width = w;
    end
  end
  for target in string.gmatch(PS_line, "[^\n]*") do
    local target2 = nil;
    local unknown = false;
    if string.len(target) == 0 then
      PS_CSG = 0;
    else
      if (PS_CSG == 1 or PS_MMT) then
        if PS_faction == "Alliance" then
          target2 = PS_GetEnemyPlayer(target);
        else
          target2 = PS_HordeEnemyP(target);
        end
        if target2 ~= nil then
          if target2.IsKOS then
            DEFAULT_CHAT_FRAME:AddMessage(PS_HPF..target, .4, 1, .2);
            if PSvars.SentrySound then
              PlaySoundFile("Interface\\AddOns\\Personal Sentry\\sounds\\hitalert.wav");
            end
          end
        end
      end
      if (PS_CSG == 1 and PSvars.SentrySound) then
        if (pos > 1 and GetTime() - PS_ClickTime > 1) then
          PlaySoundFile("Sound\\Interface\\MouseOverTarget.wav");
        elseif pos == 1 then
          PlaySoundFile("Sound\\Interface\\TalentScreenOpen.wav");
        end
        PS_ClickTime = GetTime();
      end
      if (not PS_bgmode or PS_addpop == 0) then
        target = PS_Process_Trg(target);
      end
      local isenemy = false;
      local isplayer = false;
      if PS_faction == "Alliance" then
        targetData = PS_GetFriendlyPlayer(target);
        if targetData == nil then
          targetData = PS_GetEnemyPlayer(target);
          if targetData == nil then
            targetData = PS_GetEnemyMob(target);
            if targetData == nil then
              targetData = PS_GetFriendlyMob(target);
              if targetData == nil then
                targetData = PS_GetEmptyTargetEntry();
              end
            else
              isenemy = true;
              isplayer = false;
            end
          else
            isenemy = true;
            isplayer = true;
          end
        else
          isenemy = false;
          isplayer = true;
        end
      else
        targetData = PS_HordeFriendlyP(target);
        if targetData == nil then
          targetData = PS_HordeEnemyP(target);
          if targetData == nil then
            targetData = PS_HordeEnemyM(target);
            if targetData == nil then
              targetData = PS_HordeFriendlyM(target);
              if targetData == nil then
                targetData = PS_GetEmptyTargetEntry();
              end
            else
              isenemy = true;
              isplayer = false;
            end
          else
            isenemy = true;
            isplayer = true;
          end
        else
          isenemy = false;
          isplayer = true;
        end
      end
      if targetData ~= nil then
        local level = targetData.Level;
        if tonumber(level) == -1 then
          level = (UnitLevel("player") + 10) .. "+";
        end
        if tonumber(level) == -2 then
          level = "??";
        end
        pos = pos + 1;
        health = 100;
        local button = getglobal("PS_PopupButton"..pos..PS_CombatMode..PSvars.PopupMode.."Button");
        local bar = getglobal("PS_PopupButton"..pos..PS_CombatMode..PSvars.PopupMode.."ButtonBar");
        local bg = getglobal("PS_PopupButton"..pos..PS_CombatMode..PSvars.PopupMode.."ButtonBGBar");
        local bgtext = getglobal("PS_PopupButton"..pos..PS_CombatMode..PSvars.PopupMode.."ButtonBarLeftText");
        local classicon = getglobal("PS_PopupButton"..pos..PS_CombatMode..PSvars.PopupMode.."ButtonClassIcon");
        local message = target;
        local hsdata = target;
        r1 = 0;
        g1 = 0;
        b1 = 0;
        button:SetAttribute("target", target );
        if tonumber(targetData.Level) ~= 0 then
          if( PS_CLASSES[ targetData.Class ] ) then
            classicon:SetTexCoord(unpack(PS_CLASSES[targetData.Class]));
          else
            classicon:SetTexCoord(0, .25, 0, .25);
          end
          classicon:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes");
          if isplayer then
            if(targetData.Race == nil) then
              message = message.." ("..level.." "..targetData.Class..")";
            else
              message = message.." ("..level.." "..targetData.Race.." "..targetData.Class..")";
            end
            if isenemy then
              r = PSvars.EnemyPlayer.r;
              g = PSvars.EnemyPlayer.g;
              b = PSvars.EnemyPlayer.b;
              r1 = 1;
              g1 = .35;
              b1 = .35;
            else
              r = PSvars.FriendlyPlayer.r;
              g = PSvars.FriendlyPlayer.g;
              b = PSvars.FriendlyPlayer.b;
              r1 = .35;
              g1 = 1;
              b1 = .35;
            end
          else
            message  = "NPC: "..message.." ("..level..")";
            if isenemy then
              r = PSvars.EnemyNPC.r;
              g = PSvars.EnemyNPC.g;
              b = PSvars.EnemyNPC.b;
              r1 = 1;
              g1 = .35;
              b1 = .35;
            else
              r = PSvars.FriendlyNPC.r;
              g = PSvars.FriendlyNPC.g;
              b = PSvars.FriendlyNPC.b;
              r1 = .35;
              g1 = 1;
              b1 = .35;
            end
          end
        else
          unknown = true;
          classicon:SetTexCoord(0, 1, 0, 1);
          found = string.find(message, "%s");
          if found == nil then
            message = message..PS_UNK2;
            r = PSvars.UNKPlayer.r;
            g = PSvars.UNKPlayer.g;
            b = PSvars.UNKPlayer.b;
            r1 = 1;
            g1 = 1;
            b1 = .7;
            classicon:SetTexture("Interface\\AddOns\\Personal Sentry\\images\\unk_pg");
          else
            message = message..PS_UNK2;
            r = PSvars.UNKNPC.r;
            g = PSvars.UNKNPC.g;
            b = PSvars.UNKNPC.b;
            r1 = 1;
            g1 = 1;
            b1 = .35;
            classicon:SetTexture("Interface\\AddOns\\Personal Sentry\\images\\unk_npc");
          end
        end
        getglobal("PS_PopupButton"..pos..PS_CombatMode..PSvars.PopupMode):SetBackdropBorderColor(r, g, b);
        listData = PS_GetListData(hsdata);
        if listData.pos < 1 then
          listData.pos = pos;
          listData.phase = .5;
          listData.time = GetTime();
          if listData.health == 0 then
            listData.health = 100;
          end
          if targetData.IsKOS then
            listData.damage = "HITLIST";
          end
        else
          listData.pos = pos;
          health = listData.health;
        end
        PSvars.list[hsdata] = listData;
        bar:SetStatusBarColor(r, g, b, 1);
        bg:SetStatusBarColor(r, g, b, .1);
        if not unknown then
          if PSvars.CustomPopup ~= "" then
            if targetData.Race == nil then
              message = "NPC: "..PSvars.CustomPopup;
              message = string.gsub(message, ' %%r', "");
              message = string.gsub(message, '%%r ', "");
              message = string.gsub(message, '%%r', "");
              message = string.gsub(message, ' %%c', "");
              message = string.gsub(message, '%%c ', "");
              message = string.gsub(message, '%%c', "");
            else
              message = PSvars.CustomPopup;
              message = string.gsub(message, '%%r', targetData.Race);
              message = string.gsub(message, '%%c', targetData.Class);
            end
            message = string.gsub(message, ' %%d', "");
            message = string.gsub(message, '%%d ', "");
            message = string.gsub(message, '%%d', "");
            message = string.gsub(message, '%%n', hsdata);
            message = string.gsub(message, '%%l', level);
            if string.find(message, "nohealth") then
              health = 0;
              message = string.gsub(message, ' nohealth', "");
              message = string.gsub(message, 'nohealth ', "");
              message = string.gsub(message, 'nohealth', "");
            end
            if string.find(message, '%%p') then
              message = string.gsub(message, ' %%p', "");
              message = string.gsub(message, '%%p ', "");
              message = string.gsub(message, '%%p', "");
              if (targetData.Class ~= nil and targetData.Class ~= "" and targetData.Race ~= nil) then
                local colorData = popup_class_color[targetData.Class];
                r1 = colorData.r;
                g1 = colorData.g;
                b1 = colorData.b;
                bar:SetStatusBarColor(r1 - .3, g1 - .3, b1 - .3, 1);
                bg:SetStatusBarColor(r1 - .3, g1 - .3, b1 - .3, .1);
              end
            end
          end
        end
        button:SetTextColor (r1, g1, b1);
        bar:SetValue(health);
        button:SetText(message);
        button.PS_ID = pos;
        if PS_CSG == 0 then
          button.PS_X = PS_X;
          button.PS_Y = PS_Y;
        else
          button.PS_X = 999;
          button.PS_Y = 999;
          PS_CSG = 0;
        end
        button.PS_DATA = hsdata;
        button:GetParent():Show();
        button:Show();
        local w = button:GetTextWidth();
        if w > PS_width then
          PS_width = w;
        end
      end
    end
    if pos >= PS_maxlines then
      break
    end;
  end
  if pos > 1 then
    PS_tpos = pos;
    PS_neww = PS_width;
    PS_MMT = false;
    PS_Display_Popup(PS_width + 10);
  end
end

function PS_HealthUpdate(name)

  if PSvars.CustomPopup ~= "" then
    if string.find(PSvars.CustomPopup, "nohealth") then
      return;
    end
  end
  local unitname = nil;
  local health = nil;
  local enemy = nil;
  local val = nil;
  if (name == nil and UnitName("target") == nil) then
      return;
  end
  if name == nil then
    unitname = UnitName("target");
    enemy = UnitIsEnemy("player", "target");
  else
    unitname = name;
    enemy = UnitIsEnemy("player", "mouseover");
  end
  local targetData = PS_GetUnitData(unitname);
  local listData = PS_GetListData(unitname);
  if listData.pos < 2 then
    return;
  end
  button = getglobal("PS_PopupButton"..listData.pos..PS_CombatMode..PSvars.PopupMode.."Button");
  bar = getglobal("PS_PopupButton"..listData.pos..PS_CombatMode..PSvars.PopupMode.."ButtonBar");
  if name == nil then
    health = UnitHealth("target");
  else
    health = UnitHealth("mouseover");
  end
  if not enemy then
    if name == nil then
      val = UnitHealthMax("target");
    else
      val = UnitHealthMax("mouseover");
    end
    health = health / val * 100;
  end
  listData.health = health;
  PSvars.list[unitname] = listData;
  bar:SetValue(health);
  button:GetParent():Show();
  button:Show();
  if name == nil then
    if UnitIsDeadOrGhost("target") then
      PS_DeathDetect(unitname);
    end
  else
    if UnitIsDeadOrGhost("mouseover") then
      PS_DeathDetect(unitname);
    end
  end
end

function PS_Process_Trg(trg)

  if not PSvars.tracker then
    return trg;
  end
  local counter = 0;
  for name in string.gmatch(trg, "|c%x%x%x%x%x%x%x%x([^|]+)|r") do
    trg = name;
    if counter == 0 then
      return name;
    end
  end
  return trg;
end

function PS_Display_Popup(PS_width)

  local cnt = 0;
  local numTrgs = PS_tpos;
  getglobal("PS_Popup"..PS_CombatMode..PSvars.PopupMode):SetWidth(PS_width + 60 + UNITPOPUP_BORDER_WIDTH);
  getglobal("PS_Popup"..PS_CombatMode..PSvars.PopupMode):SetHeight(PS_PopupButton1UPWARD:GetHeight() * PSvars.scale);
  getglobal("PS_Popup"..PS_CombatMode..PSvars.PopupMode):Show();
  for i=1, numTrgs do
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode):SetWidth(PS_width + 36);
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode.."Button"):SetWidth(PS_width + 4);
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode.."ButtonBar"):SetWidth(PS_width + 6);
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode.."ButtonBGBar"):SetWidth(PS_width + 6);
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode):SetScale(PSvars.scale);
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode):SetHeight(PS_PopupButton1UPWARD:GetHeight());
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode):Show();
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode):SetAlpha(1);
  end
  getglobal("PS_Popup"..PS_CombatMode..PSvars.PopupMode.."LockButton"):SetScale(PSvars.scale);
  for i=2, numTrgs do
    getglobal("PS_PopupButton"..i..PS_CombatMode.."Dam"..PSvars.PopupMode):SetScale(PSvars.scale * .75);
    getglobal("PS_PopupButton"..i..PS_CombatMode.."Dam"..PSvars.PopupMode):SetHeight(PS_PopupButton1UPWARD:GetHeight());
    getglobal("PS_PopupButton"..i..PS_CombatMode.."Dam"..PSvars.PopupMode):Show();
    getglobal("PS_PopupButton"..i..PS_CombatMode.."Dam"..PSvars.PopupMode):SetAlpha(1);
  end
  for target in string.gmatch(PS_thelist, "[^\n]*") do
    if string.len(target) > 0 then
      listData = PS_GetListData(target);
      cnt = cnt + 1;
      if cnt < 11 then
        getglobal("PS_PopupButton"..listData.pos..PS_CombatMode..PSvars.PopupMode.."ButtonBar"):SetAlpha(listData.phase);
      end
    end
  end
end

function PS_Clear_Popup()

  PS_neww = 0;
  PS_tpos = 0;
  for i=1, 11 do
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode.."Button"):SetText("");
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode).PS_DATA = "";
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode).PS_X = 999;
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode).PS_Y = 999;
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode):SetAlpha(0);
    getglobal("PS_PopupButton"..i..PS_CombatMode..PSvars.PopupMode):Hide();
  end
  PS_PopupDOWNWARD:Hide();
  PS_PopupUPWARD:Hide();
  PS_PopupComDOWNWARD:Hide();
  PS_PopupComUPWARD:Hide();
  for i=2, 11 do
    getglobal("PS_PopupButton"..i..PS_CombatMode.."Dam"..PSvars.PopupMode.."Button"):SetText("");
    getglobal("PS_PopupButton"..i..PS_CombatMode.."Dam"..PSvars.PopupMode):SetAlpha(0);
    getglobal("PS_PopupButton"..i..PS_CombatMode.."Dam"..PSvars.PopupMode):Hide();
  end
end

function PS_KeepDamage(list)

  for target in string.gmatch(list, "[^\n]*") do
    if string.len(target) > 0 then
      listData = PS_GetListData(target);
      listData.pos = 0;
      PSvars.list[target] = listData;
    end
  end
end

function PS_CombatPopup()

  if PS_CombatMode == "Com" then
    PS_Clear_Popup();
    PS_CombatMode = "";
    PS_PopupDOWNWARD:ClearAllPoints();
    PS_PopupUPWARD:ClearAllPoints();
    PS_PopupDOWNWARD:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", PSvars.DownL, PSvars.DownT);
    PS_PopupUPWARD:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", PSvars.UpL, PSvars.UpT);
    PS_dim = 1;
    PS_Process_Tooltip(PS_thelist);
  else
    PS_Clear_Popup();
    PS_CombatMode = "Com";
    PS_PopupComDOWNWARD:ClearAllPoints();
    PS_PopupComUPWARD:ClearAllPoints();
    PS_PopupComDOWNWARD:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", PSvars.DownL, PSvars.DownT);
    PS_PopupComUPWARD:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", PSvars.UpL, PSvars.UpT);
    PS_dim = 1;
    PS_Process_Tooltip(PS_thelist);
  end
end

function PS_MouseOverUpdate()

  if PS_DeathTime ~= nil then
    if GetTime() - PS_DeathTime > .6 then
      for target in string.gmatch(PS_DeathName, "[^\n]*") do
        if string.len(target) > 0 then
          PS_DeathDetect2(target);
        end
      end
    end
  end
  local SentryCheck = true;
  if (PSvars.SentryMode and PSvars.SentryChk) then
    local subzone = GetSubZoneText();
    for i = 1, table.getn(PS_NeutralZones) do
      if subzone == PS_NeutralZones[i] then
        SentryCheck = false;
      end
    end
  end
  if (PSvars.Addons == "ON" or (PSvars.Addons == "BG" and PS_bgmode)) then
    if (PSvars.SentryMode and SentryCheck and (UnitName("mouseover") ~= UnitName("target"))) then
      for target in string.gmatch(PS_thelist, "[^\n]*") do
        if string.len(target) > 0 then
          if target == UnitName("mouseover") then
            PS_FromMouse = true;
            PS_CaptureAttack(UnitName("mouseover"), "you", nil, "mouseover", 1);
          end
        end
      end
      if PSvars.tracking == "ALL" then
        if (UnitName("mouseover") ~= UnitName("player") and UnitLevel("mouseover") ~= 1 and UnitCreatureType("mouseover") ~= "Critter" and not UnitIsDeadOrGhost("mouseover")) then
          if UnitName("mouseover") ~= nil then
            if ((UnitIsPlayer("mouseover") and UnitIsPVP("mouseover")) or (UnitIsPlayer("mouseover") and IsShiftKeyDown())) then
              PS_CaptureAttack(UnitName("mouseover"), "you", nil, "mouseover", 1);
            elseif not UnitIsPlayer("mouseover") then
              local xx = 0;
              local name = UnitName("mouseover");
              for target in string.gmatch(name, "Spirit Guide") do
                xx = 1;
              end
              for target in string.gmatch(name, "Totem") do
                if not UnitIsPlayer("mouseover") then
                  xx = 1;
                end
              end
              for target in string.gmatch(name, "Trap") do
                if not UnitIsPlayer("mouseover") then
                  xx = 1;
                end
              end
                for target in string.gmatch(name, "Mechanical Squirrel") do
                  xx = 1;
                end
              if xx == 0 then
                PS_CaptureAttack(UnitName("mouseover"), "you", nil, "mouseover", 1);
                PS_HealthUpdate(UnitName("mouseover"));
              end
            end
          end
        end
      elseif PSvars.tracking == "ALL PLAYERS" then
        if (UnitName("mouseover") ~= UnitName("player") and UnitIsPlayer("mouseover") and not UnitIsDeadOrGhost("mouseover")) then
          if (UnitIsPVP("mouseover") or IsShiftKeyDown()) then
            PS_CaptureAttack(UnitName("mouseover"), "you", nil, "mouseover", 1);
            PS_HealthUpdate(UnitName("mouseover"));
          end
        end
      elseif PSvars.tracking == "ENEMIES" then
        if (UnitIsEnemy("player", "mouseover") and UnitLevel("mouseover") ~= 1 and not UnitIsDeadOrGhost("mouseover")) then
          if ((UnitIsPlayer("mouseover") and UnitIsPVP("mouseover")) or (UnitIsPlayer("mouseover") and IsShiftKeyDown())) then
            PS_CaptureAttack(UnitName("mouseover"), "you", nil, "mouseover", 1);
            PS_HealthUpdate(UnitName("mouseover"));
          elseif not UnitIsPlayer("mouseover") then
            PS_CaptureAttack(UnitName("mouseover"), "you", nil, "mouseover", 1);
            PS_HealthUpdate(UnitName("mouseover"));
          end
        end
      else
        if (UnitIsEnemy("mouseover", "player") and UnitIsPlayer("mouseover") and not UnitIsDeadOrGhost("mouseover")) then
          if (UnitIsPVP("mouseover") or IsShiftKeyDown()) then
            PS_CaptureAttack(UnitName("mouseover"), "you", nil, "mouseover", 1);
            PS_HealthUpdate(UnitName("mouseover"));
          end
        end
      end
    end
    PS_HealthUpdate(nil);
    if not UnitAffectingCombat("player") then
      PS_add = PS_phasetime;
      PS_phasetime = nil;
      if PS_add ~= nil then
        PS_skipchk = false;
        PS_CombatPopup();
      end
    else
      PS_skipchk = true;
      if PS_phasetime == nil then
        PS_CombatPopup();
        PS_phasetime = GetTime();
      end
    end
    PS_dimtimer();
    if PSvars.tracker then
      if(GetMouseFocus() ~= nil) then
        if(MouseIsOver(Minimap) and GetMouseFocus():GetName() == "Minimap") then
          if PS_mom == 0 then
            GameTooltipTextLeft1:SetText("");
            PS_mom = 1;
          end
          if GameTooltipTextLeft1:GetText() ~= PS_lasttip then
            if GameTooltipTextLeft1:GetText() ~= nil then
              local ttip = PS_Process_Trg(GameTooltipTextLeft1:GetText());
              GameTooltipTextLeft1:SetText(PS_PreParseNames(ttip));
              GameTooltip:Show();
              if((IsShiftKeyDown() or PS_bgmode and PSvars.BGMode) and GetTime() - PS_starttime > PS_mocheck) then
                local x, y = GetCursorPosition();
                x = x / Minimap:GetEffectiveScale();
                y = y / Minimap:GetEffectiveScale();
                local cx, cy = Minimap:GetCenter();
                PS_X = x + CURSOR_OFFSET_X - cx;
                PS_Y = y + CURSOR_OFFSET_Y - cy;
                PS_MOCE2();
              end
            end
            PS_lasttip = GameTooltipTextLeft1:GetText();
          end
        else
          PS_mom = 0;
        end
      else
        PS_mom = 0;
      end
    end
  end
end

function PS_dimtimer()

  local templist = "";
  for target in string.gmatch(PS_thelist, "[^\n]*") do
    if string.len(target) > 0 then
      local listData = PS_GetListData(target);
      local tmp = 0;
      if (UnitName("target") == target or UnitName("mouseover") == target) then
        listData.phase = 1;
        listData.time = GetTime();
        PSvars.list[target] = listData;
        getglobal("PS_PopupButton"..listData.pos..PS_CombatMode..PSvars.PopupMode.."ButtonBar"):SetAlpha(listData.phase)
      elseif listData.phase == 1 then
        listData.phase = .5;
        PSvars.list[target] = listData;
        getglobal("PS_PopupButton"..listData.pos..PS_CombatMode..PSvars.PopupMode.."ButtonBar"):SetAlpha(listData.phase);
      end
      if tonumber(listData.damage) ~= 0 then
        if (string.find(PSvars.CustomPopup, "%%d") or listData.damage == "HITLIST") then
          local button = getglobal("PS_PopupButton"..listData.pos..PS_CombatMode.."Dam"..PSvars.PopupMode.."Button");
          local frame = getglobal("PS_PopupButton"..listData.pos..PS_CombatMode.."Dam"..PSvars.PopupMode);
          button.id = listData.pos;
          button:SetText(listData.damage);
          button:GetParent():Show();
          button:Show();
          if listData.damage == "HITLIST" then
            UIFrameFlash(frame, .5, .5, 1, false, 0, 0);
          end
        end
      else
        local button = getglobal("PS_PopupButton"..listData.pos..PS_CombatMode.."Dam"..PSvars.PopupMode.."Button");
        button:SetText("");
        button:GetParent():Show();
        button:Show();
      end
      if GetTime() - listData.time > PSvars.SetTime then
        listData.phase = 0;
        listData.time = 0;
        listData.pos = 0;
        listData.health = 0;
        listData.damage = 0;
        PSvars.list[target] = listData;
        tmp = 1;
      elseif (GetTime() - listData.time > (PSvars.SetTime/1.5)) then
        listData.phase = 0;
        PSvars.list[target] = listData;
        getglobal("PS_PopupButton"..listData.pos..PS_CombatMode..PSvars.PopupMode.."ButtonBar"):SetAlpha(listData.phase);
      elseif (GetTime() - listData.time > (PSvars.SetTime/3)) then
        listData.phase = .25;
        PSvars.list[target] = listData;
        getglobal("PS_PopupButton"..listData.pos..PS_CombatMode..PSvars.PopupMode.."ButtonBar"):SetAlpha(listData.phase);
      end
      if tmp == 0 then
        templist = templist..target.."\n";
      end
    end
  end
  if PS_thelist ~= templist then
    PS_thelist = templist;
    PS_Clear_Popup();
    PS_dim = 1;
    PS_Process_Tooltip(PS_thelist);
  end
end

function PS_GetEmptyTargetEntry()

  return {
    Level = 0,
    Class = "",
    Race = "",
    Zone = "",
    SubZone = "",
    Notes = "",
    IsKOS = false,
    IsTemp = false
    }
end

function PS_GetEmptyListEntry()

  return {
    pos = 0,
    time = 0,
    phase = 0,
    health = 0,
    damage = 0
    }
end

function PS_GetEmptyCompareEntry()

  return {
    listed = 0
    }
end

function PS_AddDBEntry(name, data, isenemy, isplayer, faction)

  if PS_faction == "Alliance" then
    if isenemy then
      if isplayer then
        if PS_faction ~= faction then
          PSvars.EnemyPlayers[name] = data;
        end
      else
        PSvars.EnemyMobs[name] = data;
      end
    else
      if isplayer then
        PSvars.FriendlyPlayers[name] = data;
      else
        PSvars.FriendlyMobs[name] = data;
      end
    end
  else
    if isenemy then
      if isplayer then
        if PS_faction ~= faction then
          PSvars.EnemyP[name] = data;
        end
      else
        PSvars.EnemyM[name] = data;
      end
    else
      if isplayer then
        PSvars.FriendlyP[name] = data;
      else
        PSvars.FriendlyM[name] = data;
      end
    end
  end
end

function PS_GetListData(name)

  data = PSvars.list[name];
  if data ~= nil then
    return data;
  end
  return PS_GetEmptyListEntry();
end

function PS_GetCompareData(name)

  data = PSvars.compare[name];
  if data ~= nil then
    return data;
  end
  return PS_GetEmptyCompareEntry();
end

function PS_GetUnitData(name)

  if PS_faction == "Alliance" then
    data = PS_GetFriendlyPlayer(name);
    if data ~= nil then
      return data;
    end
    data = PS_GetFriendlyMob(name);
    if data ~= nil then
      return data;
    end
    data = PS_GetEnemyPlayer(name);
    if data ~= nil then
      return data;
    end
    data = PS_GetEnemyMob(name);
    if data ~= nil then
      return data;
    end
  else
    data = PS_HordeFriendlyP(name);
    if data ~= nil then
      return data;
    end
    data = PS_HordeFriendlyM(name);
    if data ~= nil then
      return data;
    end
    data = PS_HordeEnemyP(name);
    if data ~= nil then
      return data;
    end
    data = PS_HordeEnemyM(name);
    if data ~= nil then
      return data;
    end
  end
  return PS_GetEmptyTargetEntry();
end

function PS_GetEnemyPlayer(name)

  return PSvars.EnemyPlayers[name];
end

function PS_GetFriendlyPlayer(name)

  return PSvars.FriendlyPlayers[name];
end

function PS_GetEnemyMob(name)

  return PSvars.EnemyMobs[name];
end

function PS_GetFriendlyMob(name)

  return PSvars.FriendlyMobs[name];
end

function PS_HordeEnemyP(name)

  return PSvars.EnemyP[name];
end

function PS_HordeFriendlyP(name)

  return PSvars.FriendlyP[name];
end

function PS_HordeEnemyM(name)

  return PSvars.EnemyM[name];
end

function PS_HordeFriendlyM(name)

  return PSvars.FriendlyM[name];
end

function PS_DebugEcho(text)

  if PS_debugmode then
    DEFAULT_CHAT_FRAME:AddMessage("#PS DEBUG : "..text, 1, 1, 1);
  end
end